#ifndef buckets_included
#define buckets_included


    /* gc doc tells us to include pthread.h before gc.h */
    #ifdef GC_MALLOC
      #error "gc.h already included"
    #endif
    #ifndef _REENTRANT
      #define _REENTRANT
    #endif
    #include <pthread.h>
    #define GC_THREADS
    #include <gc/gc.h>


 extern char newline[]; 
#include <M2/config.h>

    #ifndef _GNU_SOURCE
    #define _GNU_SOURCE
    #endif
    #include <unistd.h>
    #ifdef HAVE_SYSCALL_H
      #include <sys/syscall.h>
    #endif
    #include <math.h>


  #include <atomic_ops.h>
  struct atomic_field {
       AO_t field;
       const char dummy; /* to prevent assignment */
       };

  #define load_Field(x) AO_load(&x.field)
  #define test_Field(x) (load_Field(x) != 0)
  #define store_Field(x,val) AO_store(&x.field,val)

  

    #include <math.h>
    #include <gmp.h>
    #include <mpfr.h>


#include <libxml/parser.h>
#include <libxml/tree.h>

/* included from scc1.c*/

#ifdef __cplusplus
  #define BASECLASS : public our_new_delete
  #include "newdelete.hpp"
#else
  #define BASECLASS
#endif

#if defined(__cplusplus)
  extern "C" {
#endif

#ifndef SAFEC_EXPORTS
#define SAFEC_EXPORTS
#endif
#ifndef SAFEC_basic_typedefs_defined
#define SAFEC_basic_typedefs_defined
typedef char M2_bool;
struct tagged_union { unsigned short type_; };
#undef M2_basic_typedefs_defined
#endif

/* typedefs */
typedef void * pthread0_voidPointer;
typedef pthread_mutex_t pthread0_ThreadMutex;
typedef pthread_attr_t pthread0_ThreadAttr;
typedef pthread_mutexattr_t pthread0_ThreadMutexAttr;
typedef pthread_cond_t pthread0_ThreadCond;
typedef pthread_condattr_t pthread0_ThreadCondAttr;
typedef pthread_key_t pthread0_ThreadKey;
typedef pthread_once_t pthread0_ThreadOnce;
typedef pthread_rwlock_t pthread0_ThreadRWLock;
typedef pthread_rwlockattr_t pthread0_ThreadRWLockAttr;
typedef struct M2_string_struct * M2_string;
typedef struct M2_arrayint_struct * M2_arrayint;
typedef M2_arrayint M2_arrayintOrNull;
typedef struct M2_stringCell_struct * M2_stringCell;
typedef struct M2_ArrayString_struct * M2_ArrayString;
typedef M2_ArrayString M2_ArrayStringOrNull;
typedef char * M2_charstar;
typedef unsigned char * M2_ucharstar;
typedef char ** M2_charstarstar;
typedef const char * M2_constcharstar;
typedef const unsigned char * M2_constucharstar;
typedef const char ** M2_constcharstarstar;
typedef char * M2_charstarOrNull;
typedef const char * M2_constcharstarOrNull;
typedef const unsigned char * M2_constucharstarOrNull;
typedef const char ** M2_constcharstarstarOrNull;
typedef struct varstrin_varstring_struct * varstrin_varstring;
typedef struct varstrin_varstringarray_struct * varstrin_varstringarray;
typedef struct nets_Net_struct * nets_Net;
typedef struct nets_NetList_struct * nets_NetList;
typedef struct vararray_vararrayint_struct * vararray_vararrayint;
typedef AO_TS_VAL_t atomic_LockValue;
typedef AO_TS_t atomic_LockField;
typedef struct atomic_field atomic_atomicField;
typedef struct atomic_field * atomic_atomicFieldPointer;
typedef struct atomic_field * atomic_atomicFieldPointerOrNull;
typedef varstrin_varstring errio_BasicFile;
typedef struct errio_BasicManipulator_struct * errio_BasicManipulator;
typedef struct stdio_file_struct * stdio_file;
typedef struct stdio_errmsg_struct * stdio_errmsg;
typedef struct stdio_FileCell_struct * stdio_FileCell;
typedef struct tagged_union * stdio_StringOrError;
typedef struct stdio_Manipulator_struct * stdio_Manipulator;
typedef struct stdiop_Position_struct * stdiop_Position;
typedef struct stdiop_PosFile_struct * stdiop_PosFile;
typedef __mpz_struct gmp_ZZstruct;
typedef __mpz_struct * gmp_ZZ;
typedef __mpz_struct * gmp_ZZorNull;
typedef struct gmp_ZZcell_struct * gmp_ZZcell;
typedef struct gmp_ZZpair_struct * gmp_ZZpair;
typedef gmp_ZZpair gmp_ZZpairOrNull;
typedef __mpq_struct gmp_QQstruct;
typedef __mpq_struct * gmp_QQ;
typedef __mpq_struct * gmp_QQorNull;
typedef struct gmp_QQcell_struct * gmp_QQcell;
typedef __mpfr_struct gmp_RRstruct;
typedef __mpfr_struct * gmp_RR;
typedef __mpfr_struct * gmp_RRorNull;
typedef struct gmp_RRcell_struct * gmp_RRcell;
typedef struct gmp_CC_struct * gmp_CC;
typedef gmp_CC gmp_CCorNull;
typedef struct gmp_CCcell_struct * gmp_CCcell;
typedef xmlNode * xml_xmlNode;
typedef xmlAttr * xml_xmlAttr;
typedef struct xml_xmlNodeCell_struct * xml_xmlNodeCell;
typedef struct xml_xmlAttrCell_struct * xml_xmlAttrCell;
typedef xmlNode * xml_xmlNodeOrNull;
typedef xmlAttr * xml_xmlAttrOrNull;
typedef const struct Monomial * engine_RawMonomial;
typedef struct engine_RawMonomialArray_struct * engine_RawMonomialArray;
typedef const struct Monomial * engine_RawMonomialOrNull;
typedef const struct MonomialOrdering * engine_RawMonomialOrdering;
typedef const struct MonomialOrdering * engine_RawMonomialOrderingOrNull;
typedef const struct Monoid * engine_RawMonoid;
typedef const struct Monoid * engine_RawMonoidOrNull;
typedef const struct Ring * engine_RawRing;
typedef const struct RingMap * engine_RawRingMap;
typedef const struct Ring * engine_RawRingOrNull;
typedef const struct RingElement * engine_RawRingElement;
typedef const struct RingElement * engine_RawRingElementOrNull;
typedef const struct MonomialIdeal * engine_RawMonomialIdeal;
typedef const struct MonomialIdeal * engine_RawMonomialIdealOrNull;
typedef const struct FreeModule * engine_RawFreeModule;
typedef const struct FreeModule * engine_RawFreeModuleOrNull;
typedef const struct Matrix * engine_RawMatrix;
typedef const struct Matrix * engine_RawMatrixOrNull;
typedef struct StraightLineProgram * engine_RawStraightLineProgram;
typedef struct StraightLineProgram * engine_RawStraightLineProgramOrNull;
typedef struct PathTracker * engine_RawPathTracker;
typedef struct PathTracker * engine_RawPathTrackerOrNull;
typedef struct MutableMatrix * engine_RawMutableMatrix;
typedef struct MutableMatrix * engine_RawMutableMatrixOrNull;
typedef struct engine_RawMonomialOrderingArray_struct * engine_RawMonomialOrderingArray;
typedef struct engine_RawMatrixPair_struct * engine_RawMatrixPair;
typedef engine_RawMatrixPair engine_RawMatrixPairOrNull;
typedef struct engine_RawMatrixArray_struct * engine_RawMatrixArray;
typedef engine_RawMatrixArray engine_RawMatrixArrayOrNull;
typedef struct engine_RawRingElementArray_struct * engine_RawRingElementArray;
typedef engine_RawRingElementArray engine_RawRingElementArrayOrNull;
typedef struct engine_RawArrayPair_struct * engine_RawArrayPair;
typedef engine_RawArrayPair engine_RawArrayPairOrNull;
typedef struct engine_RawMonomialPair_struct * engine_RawMonomialPair;
typedef struct engine_RawRingElementPair_struct * engine_RawRingElementPair;
typedef engine_RawMonomialPair engine_RawMonomialPairOrNull;
typedef engine_RawRingElementPair engine_RawRingElementPairOrNull;
typedef struct engine_RawMatrixAndInt_struct * engine_RawMatrixAndInt;
typedef struct Computation * engine_RawComputation;
typedef struct Computation * engine_RawComputationOrNull;
typedef struct engine_RawComputationCell_struct * engine_RawComputationCell;
typedef struct engine_RawFreeModuleCell_struct * engine_RawFreeModuleCell;
typedef struct engine_RawMatrixCell_struct * engine_RawMatrixCell;
typedef struct engine_RawMonoidCell_struct * engine_RawMonoidCell;
typedef struct engine_RawMonomialCell_struct * engine_RawMonomialCell;
typedef struct engine_RawMonomialIdealCell_struct * engine_RawMonomialIdealCell;
typedef struct engine_RawMonomialOrderingCell_struct * engine_RawMonomialOrderingCell;
typedef struct engine_RawMutableMatrixCell_struct * engine_RawMutableMatrixCell;
typedef struct engine_RawStraightLineProgramCell_struct * engine_RawStraightLineProgramCell;
typedef struct engine_RawPathTrackerCell_struct * engine_RawPathTrackerCell;
typedef struct engine_RawRingCell_struct * engine_RawRingCell;
typedef struct engine_RawRingElementCell_struct * engine_RawRingElementCell;
typedef struct engine_RawRingMapCell_struct * engine_RawRingMapCell;
typedef struct varnets_varnet_struct * varnets_varnet;
typedef struct varnets_vaNet_struct * varnets_vaNet;
typedef struct varnets_NetFile_struct * varnets_NetFile;
typedef struct tokens_parsefuns_struct * tokens_parsefuns;
typedef struct tokens_parseinfo_struct * tokens_parseinfo;
typedef struct tokens_Word_struct * tokens_Word;
typedef struct tokens_Symbol_struct * tokens_Symbol;
typedef struct tokens_SymbolListCell_struct * tokens_SymbolListCell;
typedef tokens_SymbolListCell tokens_SymbolList;
typedef struct tokens_SymbolHashTable_struct * tokens_SymbolHashTable;
typedef struct tokens_Dictionary_struct * tokens_Dictionary;
typedef struct tokens_Token_struct * tokens_Token;
typedef struct tokens_Adjacent_struct * tokens_Adjacent;
typedef struct tokens_For_struct * tokens_For;
typedef struct tokens_WhileDo_struct * tokens_WhileDo;
typedef struct tokens_WhileList_struct * tokens_WhileList;
typedef struct tokens_WhileListDo_struct * tokens_WhileListDo;
typedef struct tokens_TryElse_struct * tokens_TryElse;
typedef struct tokens_TryThenElse_struct * tokens_TryThenElse;
typedef struct tokens_Try_struct * tokens_Try;
typedef struct tokens_Catch_struct * tokens_Catch;
typedef struct tokens_IfThen_struct * tokens_IfThen;
typedef struct tokens_IfThenElse_struct * tokens_IfThenElse;
typedef struct tokens_New_struct * tokens_New;
typedef struct tokens_Arrow_struct * tokens_Arrow;
typedef struct tokens_Quote_struct * tokens_Quote;
typedef struct tokens_GlobalQuote_struct * tokens_GlobalQuote;
typedef struct tokens_ThreadQuote_struct * tokens_ThreadQuote;
typedef struct tokens_LocalQuote_struct * tokens_LocalQuote;
typedef struct tokens_Binary_struct * tokens_Binary;
typedef struct tokens_Unary_struct * tokens_Unary;
typedef struct tokens_Postfix_struct * tokens_Postfix;
typedef struct tokens_ArrayParseTree_struct * tokens_ArrayParseTree;
typedef struct tokens_Parentheses_struct * tokens_Parentheses;
typedef struct tokens_EmptyParentheses_struct * tokens_EmptyParentheses;
typedef struct tokens_dummy_struct * tokens_dummy;
typedef struct tokens_StartDictionary_struct * tokens_StartDictionary;
typedef struct tagged_union * tokens_ParseTree;
typedef struct tokens_TokenFile_struct * tokens_TokenFile;
typedef struct tokens_CompiledFunction_struct * tokens_CompiledFunction;
typedef struct tokens_CompiledFunctionClosure_struct * tokens_CompiledFunctionClosure;
typedef struct tokens_CompiledFunctionBody_struct * tokens_CompiledFunctionBody;
typedef struct tokens_localSymbolClosureCode_struct * tokens_localSymbolClosureCode;
typedef struct tokens_globalSymbolClosureCode_struct * tokens_globalSymbolClosureCode;
typedef struct tokens_threadSymbolClosureCode_struct * tokens_threadSymbolClosureCode;
typedef struct tokens_localMemoryReferenceCode_struct * tokens_localMemoryReferenceCode;
typedef struct tokens_globalMemoryReferenceCode_struct * tokens_globalMemoryReferenceCode;
typedef struct tokens_threadMemoryReferenceCode_struct * tokens_threadMemoryReferenceCode;
typedef struct tokens_localAssignmentCode_struct * tokens_localAssignmentCode;
typedef struct tokens_globalAssignmentCode_struct * tokens_globalAssignmentCode;
typedef struct tokens_ifCode_struct * tokens_ifCode;
typedef struct tokens_tryCode_struct * tokens_tryCode;
typedef struct tokens_catchCode_struct * tokens_catchCode;
typedef struct tokens_SymbolSequence_struct * tokens_SymbolSequence;
typedef struct tokens_parallelAssignmentCode_struct * tokens_parallelAssignmentCode;
typedef struct tokens_nullCode_struct * tokens_nullCode;
typedef struct tokens_realCode_struct * tokens_realCode;
typedef struct tokens_integerCode_struct * tokens_integerCode;
typedef struct tokens_stringCode_struct * tokens_stringCode;
typedef struct tokens_unaryCode_struct * tokens_unaryCode;
typedef struct tokens_binaryCode_struct * tokens_binaryCode;
typedef struct tokens_adjacentCode_struct * tokens_adjacentCode;
typedef struct tokens_whileDoCode_struct * tokens_whileDoCode;
typedef struct tokens_whileListCode_struct * tokens_whileListCode;
typedef struct tokens_whileListDoCode_struct * tokens_whileListDoCode;
typedef struct tokens_ternaryCode_struct * tokens_ternaryCode;
typedef struct tokens_newOfFromCode_struct * tokens_newOfFromCode;
typedef struct tokens_newFromCode_struct * tokens_newFromCode;
typedef struct tokens_newOfCode_struct * tokens_newOfCode;
typedef struct tokens_newCode_struct * tokens_newCode;
typedef struct tokens_CodeSequence_struct * tokens_CodeSequence;
typedef struct tokens_sequenceCode_struct * tokens_sequenceCode;
typedef struct tokens_listCode_struct * tokens_listCode;
typedef struct tokens_arrayCode_struct * tokens_arrayCode;
typedef struct tokens_semiCode_struct * tokens_semiCode;
typedef struct tokens_multaryCode_struct * tokens_multaryCode;
typedef struct tokens_forCode_struct * tokens_forCode;
typedef struct tokens_newLocalFrameCode_struct * tokens_newLocalFrameCode;
typedef struct tokens_functionDescription_struct * tokens_functionDescription;
typedef struct tokens_functionCode_struct * tokens_functionCode;
typedef struct tagged_union * tokens_Code;
typedef struct tokens_CodeClosure_struct * tokens_CodeClosure;
typedef struct tokens_Sequence_struct * tokens_Sequence;
typedef struct tokens_Frame_struct * tokens_Frame;
typedef struct tokens_FrameLocation_struct * tokens_FrameLocation;
typedef struct tokens_DictionaryClosure_struct * tokens_DictionaryClosure;
typedef struct tokens_FunctionClosure_struct * tokens_FunctionClosure;
typedef struct tokens_SymbolClosure_struct * tokens_SymbolClosure;
typedef struct tokens_SymbolBody_struct * tokens_SymbolBody;
typedef struct tokens_List_struct * tokens_List;
typedef struct tokens_Error_struct * tokens_Error;
typedef struct tokens_Database_struct * tokens_Database;
typedef struct tokens_SpecialExpr_struct * tokens_SpecialExpr;
typedef struct tokens_Boolean_struct * tokens_Boolean;
typedef struct tokens_Nothing_struct * tokens_Nothing;
typedef struct st_mysql * tokens_MysqlConnection;
typedef struct tokens_MysqlConnectionWrapper_struct * tokens_MysqlConnectionWrapper;
typedef struct st_mysql_res * tokens_MysqlResult;
typedef struct tokens_MysqlResultWrapper_struct * tokens_MysqlResultWrapper;
typedef struct st_mysql_field * tokens_MysqlField;
typedef struct tokens_MysqlFieldWrapper_struct * tokens_MysqlFieldWrapper;
typedef struct _object * tokens_pythonObject;
typedef struct tokens_pythonObjectCell_struct * tokens_pythonObjectCell;
typedef struct tokens_ThreadCellBody_struct * tokens_ThreadCellBody;
typedef struct tokens_ThreadCell_struct * tokens_ThreadCell;
typedef struct tagged_union * tokens_Expr;
typedef struct tokens_DictionaryList_struct * tokens_DictionaryList;
typedef struct tokens_KeyValuePair_struct * tokens_KeyValuePair;
typedef struct tokens_HashTable_struct * tokens_HashTable;
typedef struct tokens_unopNameListCell_struct * tokens_unopNameListCell;
typedef struct tokens_binopNameListCell_struct * tokens_binopNameListCell;
typedef struct tokens_ternopNameListCell_struct * tokens_ternopNameListCell;
typedef struct tokens_multopNameListCell_struct * tokens_multopNameListCell;
typedef struct lex_WordListCell_struct * lex_WordListCell;
typedef lex_WordListCell lex_WordList;
typedef struct lex_LexNode_struct * lex_LexNode;
typedef struct parser_varexprlist_struct * parser_varexprlist;
/* array types */
struct M2_string_struct {int len;char array[1];};
struct M2_arrayint_struct {int len;int array[1];};
struct M2_ArrayString_struct {int len;M2_string array[1];};
struct M2_167 {int len;nets_Net array[1];};
struct engine_RawMonomialArray_struct {int len;const struct Monomial * array[1];};
struct engine_RawMonomialOrderingArray_struct {int len;const struct MonomialOrdering * array[1];};
struct engine_RawMatrixArray_struct {int len;const struct Matrix * array[1];};
struct engine_RawRingElementArray_struct {int len;const struct RingElement * array[1];};
struct M2_540 {int len;varstrin_varstring array[1];};
struct M2_571 {int len;tokens_SymbolList array[1];};
struct tokens_ArrayParseTree_struct {int len;tokens_ParseTree array[1];};
struct tokens_SymbolSequence_struct {int len;tokens_Symbol array[1];};
struct tokens_CodeSequence_struct {unsigned short type_;int len;tokens_Code array[1];};
struct tokens_Sequence_struct {unsigned short type_;int len;tokens_Expr array[1];};
struct M2_703 {int len;tokens_KeyValuePair array[1];};
struct M2_749 {int len;lex_WordList array[1];};
struct M2_786 {int len;tokens_SymbolClosure array[1];};
/* struct types */
struct M2_stringCell_struct BASECLASS {unsigned int type_;M2_string v;};
struct varstrin_varstring_struct BASECLASS {M2_string str;int width;};
struct varstrin_varstringarray_struct BASECLASS {M2_ArrayString a;int n;};
struct nets_Net_struct BASECLASS {unsigned int type_;int height;int width;M2_ArrayString body;};
struct nets_NetList_struct BASECLASS {nets_NetList previous;nets_Net item;};
struct vararray_vararrayint_struct BASECLASS {M2_arrayint ints;int size;};
struct errio_BasicManipulator_struct BASECLASS {int (*fun)(errio_BasicFile);};
struct stdio_file_struct BASECLASS {unsigned int type_;int hash;M2_string filename;int pid;char error;M2_string errorMessage;char listener;int listenerfd;int connection;int numconns;char input;int infd;char inisatty;M2_string inbuffer;int inindex;int insize;char eof;char promptq;M2_string (*prompt)();M2_string (*reward)();char fulllines;char bol;char echo;int echoindex;char output;int outfd;char outisatty;M2_string outbuffer;int outindex;int outbol;char hadNet;nets_NetList nets;int bytesWritten;int lastCharOut;char readline;};
struct stdio_errmsg_struct BASECLASS {unsigned int type_;M2_string message;};
struct stdio_FileCell_struct BASECLASS {stdio_file file;stdio_FileCell next;};
struct stdio_Manipulator_struct BASECLASS {int (*fun)(stdio_file);};
struct stdiop_Position_struct BASECLASS {M2_string filename;unsigned short line;unsigned short column;unsigned short loadDepth;};
struct stdiop_PosFile_struct BASECLASS {unsigned int type_;stdio_file file;int lastchar;M2_string filename;unsigned short line;unsigned short column;};
struct gmp_ZZcell_struct BASECLASS {unsigned int type_;__mpz_struct * v;};
struct gmp_ZZpair_struct BASECLASS {__mpz_struct * a;__mpz_struct * b;};
struct gmp_QQcell_struct BASECLASS {unsigned int type_;__mpq_struct * v;};
struct gmp_RRcell_struct BASECLASS {unsigned int type_;__mpfr_struct * v;};
struct gmp_CC_struct BASECLASS {__mpfr_struct * re;__mpfr_struct * im;};
struct gmp_CCcell_struct BASECLASS {unsigned int type_;gmp_CC v;};
struct xml_xmlNodeCell_struct BASECLASS {unsigned int type_;xmlNode * v;};
struct xml_xmlAttrCell_struct BASECLASS {unsigned int type_;xmlAttr * v;};
struct engine_RawMatrixPair_struct BASECLASS {const struct Matrix * a;const struct Matrix * b;};
struct engine_RawArrayPair_struct BASECLASS {engine_RawMonomialArray monoms;engine_RawRingElementArray coeffs;};
struct engine_RawMonomialPair_struct BASECLASS {const struct Monomial * a;const struct Monomial * b;};
struct engine_RawRingElementPair_struct BASECLASS {const struct RingElement * a;const struct RingElement * b;};
struct engine_RawMatrixAndInt_struct BASECLASS {const struct Matrix * M;int i;};
struct engine_RawComputationCell_struct BASECLASS {unsigned int type_;struct Computation * p;};
struct engine_RawFreeModuleCell_struct BASECLASS {unsigned int type_;const struct FreeModule * p;};
struct engine_RawMatrixCell_struct BASECLASS {unsigned int type_;const struct Matrix * p;};
struct engine_RawMonoidCell_struct BASECLASS {unsigned int type_;const struct Monoid * p;};
struct engine_RawMonomialCell_struct BASECLASS {unsigned int type_;const struct Monomial * p;};
struct engine_RawMonomialIdealCell_struct BASECLASS {unsigned int type_;const struct MonomialIdeal * p;};
struct engine_RawMonomialOrderingCell_struct BASECLASS {unsigned int type_;const struct MonomialOrdering * p;};
struct engine_RawMutableMatrixCell_struct BASECLASS {unsigned int type_;struct MutableMatrix * p;};
struct engine_RawStraightLineProgramCell_struct BASECLASS {unsigned int type_;struct StraightLineProgram * p;};
struct engine_RawPathTrackerCell_struct BASECLASS {unsigned int type_;struct PathTracker * p;};
struct engine_RawRingCell_struct BASECLASS {unsigned int type_;const struct Ring * p;};
struct engine_RawRingElementCell_struct BASECLASS {unsigned int type_;const struct RingElement * p;};
struct engine_RawRingMapCell_struct BASECLASS {unsigned int type_;const struct RingMap * p;};
struct varnets_varnet_struct BASECLASS {int height;int width;struct M2_540 * body;};
struct varnets_vaNet_struct BASECLASS {struct M2_167 * nets;int size;};
struct varnets_NetFile_struct BASECLASS {unsigned int type_;varnets_vaNet v;varnets_varnet x;};
struct tokens_parsefuns_struct BASECLASS {tokens_ParseTree (*unary)(tokens_Token,tokens_TokenFile,int,char);tokens_ParseTree (*binary)(tokens_ParseTree,tokens_Token,tokens_TokenFile,int,char);};
struct tokens_parseinfo_struct BASECLASS {int precedence;int binaryStrength;int unaryStrength;tokens_parsefuns funs;};
struct tokens_Word_struct BASECLASS {M2_string name;int typecode;int hash;tokens_parseinfo parse;};
struct tokens_Symbol_struct BASECLASS {tokens_Word word;int hash;stdiop_Position position;tokens_Expr (*unary)(tokens_Code);tokens_Expr (*postfix)(tokens_Code);tokens_Expr (*binary)(tokens_Code,tokens_Code);int frameID;int frameindex;int lookupCount;char Protected;char flagLookup;char thread;};
struct tokens_SymbolListCell_struct BASECLASS {tokens_Word word;tokens_Symbol entry;tokens_SymbolList next;};
struct tokens_SymbolHashTable_struct BASECLASS {struct M2_571 * buckets;int numEntries;};
struct tokens_Dictionary_struct BASECLASS {int hash;tokens_SymbolHashTable symboltable;tokens_Dictionary outerDictionary;int frameID;int framesize;char transient;char Protected;char LocalCreationAllowed;};
struct tokens_Token_struct BASECLASS {unsigned int type_;tokens_Word word;M2_string filename;unsigned short line;unsigned short column;unsigned short loadDepth;tokens_Dictionary dictionary;tokens_Symbol entry;char followsNewline;};
struct tokens_Adjacent_struct BASECLASS {unsigned int type_;tokens_ParseTree lhs;tokens_ParseTree rhs;};
struct tokens_For_struct BASECLASS {unsigned int type_;tokens_Token forToken;tokens_ParseTree variable;tokens_ParseTree inClause;tokens_ParseTree fromClause;tokens_ParseTree toClause;tokens_ParseTree whenClause;tokens_ParseTree listClause;tokens_ParseTree doClause;tokens_Dictionary dictionary;};
struct tokens_WhileDo_struct BASECLASS {unsigned int type_;tokens_Token whileToken;tokens_ParseTree predicate;tokens_Token dotoken;tokens_ParseTree doClause;};
struct tokens_WhileList_struct BASECLASS {unsigned int type_;tokens_Token whileToken;tokens_ParseTree predicate;tokens_Token listtoken;tokens_ParseTree listClause;};
struct tokens_WhileListDo_struct BASECLASS {unsigned int type_;tokens_Token whileToken;tokens_ParseTree predicate;tokens_Token listtoken;tokens_ParseTree listClause;tokens_Token dotoken;tokens_ParseTree doClause;};
struct tokens_TryElse_struct BASECLASS {unsigned int type_;tokens_Token tryToken;tokens_ParseTree primary;tokens_Token elseToken;tokens_ParseTree alternate;};
struct tokens_TryThenElse_struct BASECLASS {unsigned int type_;tokens_Token tryToken;tokens_ParseTree primary;tokens_Token thenToken;tokens_ParseTree sequel;tokens_Token elseToken;tokens_ParseTree alternate;};
struct tokens_Try_struct BASECLASS {unsigned int type_;tokens_Token tryToken;tokens_ParseTree primary;};
struct tokens_Catch_struct BASECLASS {unsigned int type_;tokens_Token catchToken;tokens_ParseTree primary;};
struct tokens_IfThen_struct BASECLASS {unsigned int type_;tokens_Token ifToken;tokens_ParseTree predicate;tokens_ParseTree thenclause;};
struct tokens_IfThenElse_struct BASECLASS {unsigned int type_;tokens_Token ifToken;tokens_ParseTree predicate;tokens_ParseTree thenclause;tokens_ParseTree elseClause;};
struct tokens_New_struct BASECLASS {unsigned int type_;tokens_Token newtoken;tokens_ParseTree newclass;tokens_ParseTree newparent;tokens_ParseTree newinitializer;};
struct tokens_Arrow_struct BASECLASS {unsigned int type_;tokens_ParseTree lhs;tokens_Token Operator;tokens_ParseTree rhs;tokens_functionDescription desc;};
struct tokens_Quote_struct BASECLASS {unsigned int type_;tokens_Token Operator;tokens_Token rhs;};
struct tokens_GlobalQuote_struct BASECLASS {unsigned int type_;tokens_Token Operator;tokens_Token rhs;};
struct tokens_ThreadQuote_struct BASECLASS {unsigned int type_;tokens_Token Operator;tokens_Token rhs;};
struct tokens_LocalQuote_struct BASECLASS {unsigned int type_;tokens_Token Operator;tokens_Token rhs;};
struct tokens_Binary_struct BASECLASS {unsigned int type_;tokens_ParseTree lhs;tokens_Token Operator;tokens_ParseTree rhs;};
struct tokens_Unary_struct BASECLASS {unsigned int type_;tokens_Token Operator;tokens_ParseTree rhs;};
struct tokens_Postfix_struct BASECLASS {unsigned int type_;tokens_ParseTree lhs;tokens_Token Operator;};
struct tokens_Parentheses_struct BASECLASS {unsigned int type_;tokens_Token left;tokens_ParseTree contents;tokens_Token right;};
struct tokens_EmptyParentheses_struct BASECLASS {unsigned int type_;tokens_Token left;tokens_Token right;};
struct tokens_dummy_struct BASECLASS {unsigned int type_;stdiop_Position position;};
struct tokens_StartDictionary_struct BASECLASS {unsigned int type_;tokens_Dictionary dictionary;tokens_ParseTree body;};
struct tokens_TokenFile_struct BASECLASS {unsigned int type_;stdiop_PosFile posFile;tokens_Token nexttoken;};
struct tokens_CompiledFunction_struct BASECLASS {unsigned int type_;tokens_Expr (*fn)(tokens_Expr);int hash;};
struct tokens_CompiledFunctionClosure_struct BASECLASS {unsigned int type_;tokens_Expr (*fn)(tokens_Expr,tokens_Sequence);int hash;tokens_Sequence env;};
struct tokens_CompiledFunctionBody_struct BASECLASS {unsigned int type_;tokens_Expr (*fn)(tokens_Expr,tokens_Sequence);};
struct tokens_localSymbolClosureCode_struct BASECLASS {unsigned int type_;int nestingDepth;tokens_Symbol symbol;stdiop_Position position;};
struct tokens_globalSymbolClosureCode_struct BASECLASS {unsigned int type_;tokens_Symbol symbol;stdiop_Position position;};
struct tokens_threadSymbolClosureCode_struct BASECLASS {unsigned int type_;tokens_Symbol symbol;stdiop_Position position;};
struct tokens_localMemoryReferenceCode_struct BASECLASS {unsigned int type_;int nestingDepth;int frameindex;stdiop_Position position;};
struct tokens_globalMemoryReferenceCode_struct BASECLASS {unsigned int type_;int frameindex;stdiop_Position position;};
struct tokens_threadMemoryReferenceCode_struct BASECLASS {unsigned int type_;int frameindex;stdiop_Position position;};
struct tokens_localAssignmentCode_struct BASECLASS {unsigned int type_;int nestingDepth;int frameindex;tokens_Code rhs;stdiop_Position position;};
struct tokens_globalAssignmentCode_struct BASECLASS {unsigned int type_;tokens_Symbol lhs;tokens_Code rhs;stdiop_Position position;};
struct tokens_ifCode_struct BASECLASS {unsigned int type_;tokens_Code predicate;tokens_Code thenClause;tokens_Code elseClause;stdiop_Position position;};
struct tokens_tryCode_struct BASECLASS {unsigned int type_;tokens_Code code;tokens_Code thenClause;tokens_Code elseClause;stdiop_Position position;};
struct tokens_catchCode_struct BASECLASS {unsigned int type_;tokens_Code code;stdiop_Position position;};
struct tokens_parallelAssignmentCode_struct BASECLASS {unsigned int type_;M2_arrayint nestingDepth;M2_arrayint frameindex;tokens_SymbolSequence lhs;tokens_Code rhs;stdiop_Position position;};
struct tokens_nullCode_struct BASECLASS {unsigned int type_;};
struct tokens_realCode_struct BASECLASS {unsigned int type_;__mpfr_struct * x;stdiop_Position position;};
struct tokens_integerCode_struct BASECLASS {unsigned int type_;__mpz_struct * x;stdiop_Position position;};
struct tokens_stringCode_struct BASECLASS {unsigned int type_;M2_string x;};
struct tokens_unaryCode_struct BASECLASS {unsigned int type_;tokens_Expr (*f)(tokens_Code);tokens_Code rhs;stdiop_Position position;};
struct tokens_binaryCode_struct BASECLASS {unsigned int type_;tokens_Expr (*f)(tokens_Code,tokens_Code);tokens_Code lhs;tokens_Code rhs;stdiop_Position position;};
struct tokens_adjacentCode_struct BASECLASS {unsigned int type_;tokens_Code lhs;tokens_Code rhs;stdiop_Position position;};
struct tokens_whileDoCode_struct BASECLASS {unsigned int type_;tokens_Code predicate;tokens_Code doClause;stdiop_Position position;};
struct tokens_whileListCode_struct BASECLASS {unsigned int type_;tokens_Code predicate;tokens_Code listClause;stdiop_Position position;};
struct tokens_whileListDoCode_struct BASECLASS {unsigned int type_;tokens_Code predicate;tokens_Code listClause;tokens_Code doClause;stdiop_Position position;};
struct tokens_ternaryCode_struct BASECLASS {unsigned int type_;tokens_Expr (*f)(tokens_Code,tokens_Code,tokens_Code);tokens_Code arg1;tokens_Code arg2;tokens_Code arg3;stdiop_Position position;};
struct tokens_newOfFromCode_struct BASECLASS {unsigned int type_;tokens_Code newClause;tokens_Code ofClause;tokens_Code fromClause;stdiop_Position position;};
struct tokens_newFromCode_struct BASECLASS {unsigned int type_;tokens_Code newClause;tokens_Code fromClause;stdiop_Position position;};
struct tokens_newOfCode_struct BASECLASS {unsigned int type_;tokens_Code newClause;tokens_Code ofClause;stdiop_Position position;};
struct tokens_newCode_struct BASECLASS {unsigned int type_;tokens_Code newClause;stdiop_Position position;};
struct tokens_sequenceCode_struct BASECLASS {unsigned int type_;tokens_CodeSequence x;stdiop_Position position;};
struct tokens_listCode_struct BASECLASS {unsigned int type_;tokens_CodeSequence y;stdiop_Position position;};
struct tokens_arrayCode_struct BASECLASS {unsigned int type_;tokens_CodeSequence z;stdiop_Position position;};
struct tokens_semiCode_struct BASECLASS {unsigned int type_;tokens_CodeSequence w;stdiop_Position position;};
struct tokens_multaryCode_struct BASECLASS {unsigned int type_;tokens_Expr (*f)(tokens_CodeSequence);tokens_CodeSequence args;stdiop_Position position;};
struct tokens_forCode_struct BASECLASS {unsigned int type_;tokens_Code inClause;tokens_Code fromClause;tokens_Code toClause;tokens_Code whenClause;tokens_Code listClause;tokens_Code doClause;int frameID;int framesize;stdiop_Position position;};
struct tokens_newLocalFrameCode_struct BASECLASS {unsigned int type_;int frameID;int framesize;tokens_Code body;};
struct tokens_functionDescription_struct BASECLASS {int frameID;int framesize;int numparms;char restargs;};
struct tokens_functionCode_struct BASECLASS {unsigned int type_;tokens_Token arrow;tokens_Code body;tokens_functionDescription desc;int hash;};
struct tokens_CodeClosure_struct BASECLASS {unsigned int type_;tokens_Frame frame;tokens_Code code;};
struct tokens_Frame_struct BASECLASS {tokens_Frame outerFrame;int frameID;int valuesUsed;char notrecyclable;tokens_Sequence values;};
struct tokens_FrameLocation_struct BASECLASS {tokens_Frame frame;int frameindex;};
struct tokens_DictionaryClosure_struct BASECLASS {unsigned int type_;tokens_Frame frame;tokens_Dictionary dictionary;};
struct tokens_FunctionClosure_struct BASECLASS {unsigned int type_;tokens_Frame frame;tokens_functionCode model;};
struct tokens_SymbolClosure_struct BASECLASS {unsigned int type_;tokens_Frame frame;tokens_Symbol symbol;};
struct tokens_SymbolBody_struct BASECLASS {unsigned int type_;tokens_Symbol symbol;};
struct tokens_List_struct BASECLASS {unsigned int type_;tokens_HashTable Class;tokens_Sequence v;int hash;char Mutable;};
struct tokens_Error_struct BASECLASS {unsigned int type_;stdiop_Position position;M2_string message;tokens_Expr value;char printed;tokens_Frame frame;};
struct tokens_Database_struct BASECLASS {unsigned int type_;M2_string filename;int hash;int handle;char isopen;char Mutable;};
struct tokens_SpecialExpr_struct BASECLASS {unsigned int type_;tokens_HashTable Class;tokens_Expr e;};
struct tokens_Boolean_struct BASECLASS {unsigned int type_;char v;};
struct tokens_Nothing_struct BASECLASS {unsigned int type_;};
struct tokens_MysqlConnectionWrapper_struct BASECLASS {unsigned int type_;struct st_mysql * mysql;};
struct tokens_MysqlResultWrapper_struct BASECLASS {unsigned int type_;tokens_MysqlConnectionWrapper connection;struct st_mysql_res * res;};
struct tokens_MysqlFieldWrapper_struct BASECLASS {unsigned int type_;tokens_MysqlResultWrapper res;struct st_mysql_field * fld;};
struct tokens_pythonObjectCell_struct BASECLASS {unsigned int type_;struct _object * v;};
struct tokens_ThreadCellBody_struct BASECLASS {unsigned int type_;pthread_t thread;int tid;char done;char cancellationRequested;char resultRetrieved;tokens_Expr fun;tokens_Expr arg;tokens_Expr returnValue;atomic_atomicFieldPointerOrNull exceptionFlagPointer;atomic_atomicFieldPointerOrNull interruptedFlagPointer;};
struct tokens_ThreadCell_struct BASECLASS {unsigned int type_;tokens_ThreadCellBody body;};
struct tokens_DictionaryList_struct BASECLASS {tokens_Dictionary dictionary;tokens_DictionaryList next;};
struct tokens_KeyValuePair_struct BASECLASS {tokens_Expr key;int hash;tokens_Expr value;tokens_KeyValuePair next;};
struct tokens_HashTable_struct BASECLASS {unsigned int type_;struct M2_703 * table;tokens_HashTable Class;tokens_HashTable parent;int numEntries;int hash;char Mutable;char beingInitialized;};
struct tokens_unopNameListCell_struct BASECLASS {tokens_Expr (*f)(tokens_Code);M2_string name;tokens_unopNameListCell next;};
struct tokens_binopNameListCell_struct BASECLASS {tokens_Expr (*f)(tokens_Code,tokens_Code);M2_string name;tokens_binopNameListCell next;};
struct tokens_ternopNameListCell_struct BASECLASS {tokens_Expr (*f)(tokens_Code,tokens_Code,tokens_Code);M2_string name;tokens_ternopNameListCell next;};
struct tokens_multopNameListCell_struct BASECLASS {tokens_Expr (*f)(tokens_CodeSequence);M2_string name;tokens_multopNameListCell next;};
struct lex_WordListCell_struct BASECLASS {tokens_Word word;lex_WordList next;};
struct lex_LexNode_struct BASECLASS {char ch;tokens_Word word;lex_LexNode next;lex_LexNode further;};
struct parser_varexprlist_struct BASECLASS {tokens_ArrayParseTree list;int size;};
/* basic types */
typedef void * (*pthread0_threadFunction)(void *);
typedef tokens_Expr (*tokens_unop)(tokens_Code);
typedef tokens_Expr (*tokens_binop)(tokens_Code,tokens_Code);
typedef tokens_Expr (*tokens_binopExpr)(tokens_Expr,tokens_Expr);
typedef tokens_Expr (*tokens_ternop)(tokens_Code,tokens_Code,tokens_Code);
typedef tokens_Expr (*tokens_multop)(tokens_CodeSequence);
typedef tokens_Expr (*tokens_fun)(tokens_Expr);
/* functions */
extern void buckets__prepare() __attribute__ ((constructor));
extern void common__prepare() __attribute__ ((constructor));
extern tokens_Expr common_keys(tokens_Database);
extern tokens_Expr common_dbmreorganize(tokens_Database);
extern tokens_Expr common_dbmfirst(tokens_Database);
extern tokens_Expr common_dbmquery(tokens_Database,M2_string);
extern tokens_Expr common_dbmstore(tokens_Database,M2_string,M2_string);
extern tokens_Expr common_dbmclose(tokens_Database);
extern tokens_Expr common_dbmopenout(M2_string);
extern tokens_Expr common_dbmopenin(M2_string);
extern tokens_Expr common_dbmcheck(int);
extern tokens_Expr common_MissingAssignmentMethodPair(tokens_Expr,tokens_Expr,tokens_Expr);
extern tokens_Expr common_MissingAssignmentMethod(tokens_Expr,tokens_Expr);
extern tokens_Expr common_MissingMethodPair_3(M2_string,tokens_Expr,tokens_Expr);
extern tokens_Expr common_MissingMethodPair_2(tokens_SymbolClosure,tokens_Expr,tokens_Expr);
extern tokens_Expr common_MissingMethodPair_1(tokens_SymbolClosure);
extern tokens_Expr common_MissingMethodPair(M2_string);
extern tokens_Expr common_MissingMethod_1(tokens_SymbolClosure);
extern tokens_Expr common_MissingMethod(M2_string,M2_string);
extern tokens_Expr common_WrongNumArgs_5(tokens_Token,int,int);
extern tokens_Expr common_WrongNumArgs_4(tokens_Code,int,int);
extern tokens_Expr common_returnFromLoop(tokens_Expr);
extern tokens_Expr common_returnFromFunction(tokens_Expr);
extern tokens_Expr common_printErrorMessageE_2(tokens_Token,M2_string);
extern tokens_Expr common_printErrorMessageE_1(stdiop_Position,M2_string);
extern tokens_Expr common_printErrorMessageE(tokens_Code,M2_string);
extern tokens_Error common_printErrorMessage0(tokens_Code,M2_string);
extern __thread unsigned short common_errorDepth;
extern tokens_Expr common_TooManyArgs(M2_string,int);
extern tokens_Expr common_TooFewArgs(M2_string,int);
extern tokens_Expr common_WrongNumArgs_3(int,int);
extern tokens_Expr common_WrongNumArgs_2(M2_string,int,int);
extern tokens_Expr common_WrongNumArgs_1(int);
extern tokens_Expr common_WrongNumArgs(M2_string,int);
extern tokens_Expr common_ArgChanged(M2_string,int);
extern tokens_Expr common_WrongArgMatrix_1();
extern tokens_Expr common_WrongArgMatrix(int);
extern tokens_Expr common_WrongArgMutableMatrix_1();
extern tokens_Expr common_WrongArgMutableMatrix(int);
extern tokens_Expr common_WrongArgBoolean_1(int);
extern tokens_Expr common_WrongArgBoolean();
extern tokens_Expr common_WrongArgString_1(int);
extern tokens_Expr common_WrongArgString();
extern tokens_Expr common_WrongArgSmallUInteger_1(int);
extern tokens_Expr common_WrongArgSmallUInteger();
extern tokens_Expr common_WrongArgSmallInteger_1(int);
extern tokens_Expr common_WrongArgSmallInteger();
extern tokens_Expr common_WrongArgRR_1(int);
extern tokens_Expr common_WrongArgRR();
extern tokens_Expr common_WrongArgZZ_1(int);
extern tokens_Expr common_WrongArgZZ();
extern tokens_Expr common_WrongArg_1(int,M2_string);
extern tokens_Expr common_WrongArg(M2_string);
extern tokens_Expr common_NotYet(M2_string);
extern M2_string common_quoteit(M2_string);
extern tokens_Symbol common_setupconst(M2_string,tokens_Expr);
extern tokens_Symbol common_setupvarThread(M2_string,tokens_Expr);
extern tokens_Symbol common_setupvar_1(M2_string,tokens_Expr);
extern tokens_Symbol common_setupvar(M2_string,tokens_Expr,char);
extern tokens_Symbol common_setupfun_1(M2_string,tokens_fun);
extern tokens_Symbol common_setupfun(M2_string,tokens_unop);
extern void common_setupop(tokens_SymbolClosure,tokens_unop);
extern void common_setup_8(tokens_SymbolClosure,tokens_unop,tokens_unop);
extern void common_setup_7(tokens_SymbolClosure,tokens_unop,tokens_binop);
extern void common_setup_6(tokens_SymbolClosure,tokens_binop);
extern void common_setuppostfix(tokens_SymbolClosure,tokens_unop);
extern void common_setup_5(tokens_SymbolClosure,tokens_unop);
extern void common_setup_4(tokens_Word,tokens_unop,tokens_unop);
extern void common_setup_3(tokens_Word,tokens_unop,tokens_binop);
extern void common_setup_2(tokens_Word,tokens_binop);
extern void common_setup_1(tokens_Word,tokens_unop);
extern void common_setup(tokens_Word);
extern M2_string common_tostring(tokens_Code);
extern void common_pos(tokens_Code);
extern stdiop_Position common_codePosition(tokens_Code);
extern void binding__prepare() __attribute__ ((constructor));
extern char binding_localBind(tokens_ParseTree,tokens_Dictionary);
extern void binding_bind(tokens_ParseTree,tokens_Dictionary);
extern struct M2_786 * binding_fixedPostfixOperators;
extern struct M2_786 * binding_fixedPrefixOperators;
extern struct M2_786 * binding_fixedBinaryOperators;
extern struct M2_786 * binding_opsWithPostfixMethod;
extern struct M2_786 * binding_opsWithUnaryMethod;
extern struct M2_786 * binding_opsWithBinaryMethod;
extern tokens_Symbol binding_lookup_1(tokens_Word,tokens_Dictionary);
extern tokens_Symbol binding_globalLookup(tokens_Word);
extern tokens_Symbol binding_lookup(tokens_Word,tokens_SymbolHashTable);
extern void binding_makeErrorTree_1(tokens_Token,M2_string);
extern void binding_makeErrorTree(tokens_ParseTree,M2_string);
extern tokens_Symbol binding_makeSymbol_3(tokens_Token);
extern tokens_Expr binding_InverseE;
extern tokens_SymbolClosure binding_InverseS;
extern tokens_Expr binding_NewOfFromE;
extern tokens_SymbolClosure binding_NewOfFromS;
extern tokens_Expr binding_NewFromE;
extern tokens_SymbolClosure binding_NewFromS;
extern tokens_Expr binding_NewOfE;
extern tokens_SymbolClosure binding_NewOfS;
extern tokens_Expr binding_NewE;
extern tokens_SymbolClosure binding_NewS;
extern tokens_Expr binding_incomparableE;
extern tokens_Expr binding_GreaterE;
extern tokens_Expr binding_LessE;
extern tokens_Expr binding_EqualEqualE;
extern tokens_Expr binding_LeftArrowE;
extern tokens_Expr binding_EqualE;
extern tokens_Expr binding_GlobalReleaseE;
extern tokens_SymbolClosure binding_GlobalReleaseS;
extern tokens_Expr binding_GlobalAssignE;
extern tokens_SymbolClosure binding_GlobalAssignS;
extern tokens_SymbolClosure binding_ExclamationS;
extern tokens_SymbolClosure binding_DotQuestionS;
extern tokens_SymbolClosure binding_DotS;
extern tokens_SymbolClosure binding_SharpQuestionS;
extern tokens_SymbolClosure binding_SharpS;
extern tokens_SymbolClosure binding_UnderscoreS;
extern tokens_SymbolClosure binding_PowerStarStarS;
extern tokens_SymbolClosure binding_PowerS;
extern tokens_SymbolClosure binding_PowerStarS;
extern tokens_SymbolClosure binding_UnderscoreStarS;
extern tokens_SymbolClosure binding_TildeS;
extern tokens_SymbolClosure binding_AtAtS;
extern tokens_SymbolClosure binding_ParenStarParenS;
extern tokens_SymbolClosure binding_stepS;
extern tokens_SymbolClosure binding_continueS;
extern tokens_SymbolClosure binding_breakS;
extern tokens_SymbolClosure binding_returnS;
extern tokens_SymbolClosure binding_throwS;
extern tokens_SymbolClosure binding_shieldS;
extern tokens_SymbolClosure binding_timingS;
extern tokens_SymbolClosure binding_timeS;
extern tokens_Word binding_leftbrace;
extern tokens_Word binding_leftparen;
extern tokens_SymbolClosure binding_AdjacentS;
extern tokens_SymbolClosure binding_AtS;
extern tokens_SymbolClosure binding_SlashSlashS;
extern tokens_SymbolClosure binding_PercentS;
extern tokens_SymbolClosure binding_LeftDivideS;
extern tokens_SymbolClosure binding_DivideS;
extern tokens_SymbolClosure binding_StarS;
extern tokens_SymbolClosure binding_BackslashBackslashS;
extern tokens_Word binding_leftbracket;
extern tokens_SymbolClosure binding_StarStarS;
extern tokens_SymbolClosure binding_PlusPlusS;
extern tokens_SymbolClosure binding_PlusS;
extern tokens_SymbolClosure binding_MinusS;
extern tokens_SymbolClosure binding_DotDotLessS;
extern tokens_SymbolClosure binding_DotDotS;
extern tokens_SymbolClosure binding_AmpersandS;
extern tokens_SymbolClosure binding_HatHatS;
extern tokens_SymbolClosure binding_BarS;
extern tokens_SymbolClosure binding_ColonS;
extern tokens_SymbolClosure binding_BarBarS;
extern tokens_SymbolClosure binding_NotEqualS;
extern tokens_SymbolClosure binding_NotEqualEqualEqualS;
extern tokens_SymbolClosure binding_QuestionS;
extern tokens_SymbolClosure binding_EqualEqualS;
extern tokens_SymbolClosure binding_EqualEqualEqualS;
extern tokens_SymbolClosure binding_GreaterEqualS;
extern tokens_SymbolClosure binding_LessEqualS;
extern tokens_SymbolClosure binding_GreaterS;
extern tokens_SymbolClosure binding_LessS;
extern tokens_SymbolClosure binding_incomparableS;
extern tokens_SymbolClosure binding_notS;
extern tokens_SymbolClosure binding_andS;
extern tokens_SymbolClosure binding_orS;
extern tokens_SymbolClosure binding_LongDoubleLeftArrowS;
extern tokens_SymbolClosure binding_LongDoubleRightArrowS;
extern tokens_SymbolClosure binding_LongBiDoubleArrowS;
extern tokens_SymbolClosure binding_LongLongDoubleLeftArrowS;
extern tokens_SymbolClosure binding_LongLongDoubleRightArrowS;
extern tokens_SymbolClosure binding_DeductionS;
extern tokens_SymbolClosure binding_LessLessS;
extern tokens_SymbolClosure binding_GreaterGreaterS;
extern tokens_SymbolClosure binding_DoubleArrowS;
extern tokens_SymbolClosure binding_RightArrowS;
extern tokens_Word binding_RightArrowW;
extern tokens_SymbolClosure binding_LeftArrowS;
extern tokens_Word binding_LeftArrowW;
extern tokens_SymbolClosure binding_EqualS;
extern tokens_Word binding_EqualW;
extern tokens_SymbolClosure binding_ColonEqualS;
extern tokens_Word binding_ColonEqualW;
extern tokens_SymbolClosure binding_commaS;
extern tokens_Word binding_CommaW;
extern tokens_SymbolClosure binding_SemicolonS;
extern tokens_Word binding_SemicolonW;
extern tokens_SymbolClosure binding_makeProtectedSymbolClosure_1(M2_string);
extern tokens_SymbolClosure binding_makeProtectedSymbolClosure(tokens_Word);
extern tokens_Symbol binding_makeSymbol_2(tokens_Word,stdiop_Position,tokens_Dictionary);
extern tokens_Symbol binding_makeSymbol_1(tokens_Word,stdiop_Position,tokens_Dictionary,char);
extern tokens_Symbol binding_makeSymbol(tokens_Word,stdiop_Position,tokens_Dictionary,char,char);
extern tokens_Symbol binding_makeEntry_1(tokens_Word,stdiop_Position,tokens_Dictionary);
extern tokens_Symbol binding_makeEntry(tokens_Word,stdiop_Position,tokens_Dictionary,char,char);
extern tokens_Symbol binding_insert_1(tokens_SymbolHashTable,tokens_Word,tokens_Symbol);
extern tokens_Symbol binding_insert(tokens_Symbol,tokens_SymbolHashTable);
extern void parser__prepare() __attribute__ ((constructor));
extern int parser_size(tokens_ParseTree);
extern stdiop_Position parser_treePosition(tokens_ParseTree);
extern tokens_ParseTree parser_unarynew(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unarycatch(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unarytry(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unaryif(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unarylocal(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unarythread(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unaryglobal(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unarysymbol(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unaryfor(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unarywhile(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unaryparen(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ArrayParseTree parser_toexprlist(parser_varexprlist);
extern parser_varexprlist parser_less_less_(parser_varexprlist,tokens_ParseTree);
extern parser_varexprlist parser_newvarexprlist(int);
extern void parser_addmatch(M2_string,M2_string);
extern tokens_ParseTree parser_arrowop(tokens_ParseTree,tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_nbinaryop(tokens_ParseTree,tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_binaryop(tokens_ParseTree,tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_nparse(tokens_TokenFile,int,char);
extern tokens_ParseTree parser_parse(tokens_TokenFile,int,char);
extern tokens_ParseTree parser_postfixop(tokens_ParseTree,tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_defaultbinary(tokens_ParseTree,tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_nnunaryop(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_nunaryop(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_unaryop(tokens_Token,tokens_TokenFile,int,char);
extern int parser_precSpace;
extern tokens_ParseTree parser_defaultunary(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_errorbinary(tokens_ParseTree,tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_errorunary(tokens_Token,tokens_TokenFile,int,char);
extern tokens_ParseTree parser_errorTree;
extern tokens_Token parser_peektoken(tokens_TokenFile,char);
extern tokens_Token parser_gettoken(tokens_TokenFile,char);
extern void parser_unsetprompt(tokens_TokenFile);
extern void parser_setprompt(tokens_TokenFile,M2_string (*)());
extern struct tagged_union * parser_openTokenFile(M2_string);
extern stdio_file parser_tracefile;
extern char parser_debug;
extern tokens_Word parser_toW;
extern tokens_Word parser_inW;
extern tokens_Word parser_fromW;
extern tokens_Word parser_listW;
extern tokens_Word parser_doW;
extern tokens_Word parser_ofW;
extern tokens_Word parser_elseW;
extern tokens_Word parser_whenW;
extern tokens_Word parser_thenW;
extern M2_string parser_parseString(M2_string);
extern int parser_hexvalue_1(int);
extern int parser_hexvalue(char);
extern __mpfr_struct * parser_parseRR(M2_string);
extern __mpz_struct * parser_parseInt(M2_string);
extern void lex__prepare() __attribute__ ((constructor));
extern tokens_Token lex_gettoken(stdiop_PosFile,char);
extern tokens_Token lex_errorToken;
extern tokens_Word lex_install(M2_string,tokens_Word);
extern void lex_dumpNodes();
extern lex_LexNode lex_baseLexNode;
extern stdio_file lex_less_less__1(stdio_file,tokens_Token);
extern char lex_equal(tokens_ParseTree,tokens_Word);
extern tokens_Word lex_NewlineW;
extern tokens_Word lex_makeUniqueWord(M2_string,tokens_parseinfo);
extern struct M2_749 * lex_hashTable;
extern stdio_file lex_less_less_(stdio_file,tokens_Word);
extern tokens_Word lex_wordEOC;
extern tokens_Word lex_wordEOF;
extern void basic__prepare() __attribute__ ((constructor));
extern tokens_Expr basic_Array_5(tokens_Expr,tokens_Expr,tokens_Expr,tokens_Expr);
extern tokens_Expr basic_Array_4(tokens_Expr,tokens_Expr,tokens_Expr);
extern tokens_Expr basic_Array_3(tokens_Expr,tokens_Expr);
extern tokens_Expr basic_Array_2();
extern tokens_Expr basic_emptyArray;
extern tokens_Expr basic_Array_1(tokens_Expr);
extern tokens_Expr basic_Array(tokens_Sequence);
extern tokens_Expr basic_list_8(tokens_Expr,tokens_Expr,tokens_Expr,tokens_Expr);
extern tokens_Expr basic_list_7(tokens_Expr,tokens_Expr,tokens_Expr);
extern tokens_Expr basic_list_6(tokens_Expr,tokens_Expr);
extern tokens_Expr basic_list_5(tokens_Expr);
extern tokens_Expr basic_list_4();
extern tokens_Expr basic_emptyList;
extern tokens_Expr basic_list_3(tokens_HashTable,tokens_Expr);
extern tokens_Expr basic_list_2(tokens_HashTable,tokens_Sequence,char);
extern tokens_Expr basic_list_1(tokens_HashTable,tokens_Sequence);
extern tokens_Expr basic_list(tokens_Sequence);
extern tokens_Expr basic_seq_2(tokens_Expr,tokens_Expr,tokens_Expr);
extern tokens_Expr basic_seq_1(tokens_Expr,tokens_Expr);
extern tokens_Expr basic_seq();
extern tokens_List basic_reverse_1(tokens_List);
extern tokens_Sequence basic_reverse(tokens_Sequence);
extern tokens_List basic_copy_1(tokens_List);
extern tokens_Sequence basic_copy(tokens_Sequence);
extern tokens_List basic_sethash(tokens_List,char);
extern int basic_hash_1(tokens_List);
extern int basic_hash(tokens_Expr);
extern void tokens__prepare() __attribute__ ((constructor));
extern M2_string tokens_getMultopName(tokens_multop);
extern M2_string tokens_getTernopName(tokens_ternop);
extern M2_string tokens_getBinopName(tokens_binop);
extern M2_string tokens_getUnopName(tokens_unop);
extern tokens_multopNameListCell tokens_multopNameList;
extern tokens_ternopNameListCell tokens_ternopNameList;
extern tokens_binopNameListCell tokens_binopNameList;
extern tokens_unopNameListCell tokens_unopNameList;
extern tokens_Expr tokens_dummyMultop(tokens_CodeSequence);
extern tokens_Expr tokens_dummyTernop(tokens_Code,tokens_Code,tokens_Code);
extern tokens_Expr tokens_dummyBinop(tokens_Code,tokens_Code);
extern tokens_Expr tokens_dummyUnop(tokens_Code);
extern char tokens_equal_equal_equal__11(tokens_Expr,tokens_Symbol);
extern char tokens_equal_equal_equal__10(tokens_Symbol,tokens_Expr);
extern char tokens_equal_equal_equal__9(tokens_Expr,tokens_SymbolClosure);
extern char tokens_equal_equal_equal__8(tokens_SymbolClosure,tokens_Expr);
extern char tokens_equal_equal_equal__7(tokens_SymbolBody,tokens_Symbol);
extern char tokens_equal_equal_equal__6(tokens_SymbolClosure,tokens_Symbol);
extern char tokens_equal_equal_equal__5(tokens_Symbol,tokens_SymbolBody);
extern char tokens_equal_equal_equal__4(tokens_Symbol,tokens_SymbolClosure);
extern char tokens_equal_equal_equal__3(tokens_SymbolBody,tokens_SymbolClosure);
extern char tokens_equal_equal_equal__2(tokens_SymbolClosure,tokens_SymbolBody);
extern char tokens_equal_equal_equal__1(tokens_SymbolBody,tokens_SymbolBody);
extern char tokens_equal_equal_equal_(tokens_SymbolClosure,tokens_SymbolClosure);
extern tokens_HashTable tokens_symbolBodyClass;
extern tokens_HashTable tokens_threadClass;
extern tokens_HashTable tokens_xmlAttrClass;
extern tokens_HashTable tokens_xmlNodeClass;
extern tokens_HashTable tokens_pythonObjectClass;
extern tokens_HashTable tokens_rawPathTrackerClass;
extern tokens_HashTable tokens_nothingClass;
extern tokens_HashTable tokens_rawComputationClass;
extern tokens_HashTable tokens_rawStraightLineProgramClass;
extern tokens_HashTable tokens_rawMutableMatrixClass;
extern tokens_HashTable tokens_rawMatrixClass;
extern tokens_HashTable tokens_rawFreeModuleClass;
extern tokens_HashTable tokens_rawRingMapClass;
extern tokens_HashTable tokens_rawRingElementClass;
extern tokens_HashTable tokens_rawRingClass;
extern tokens_HashTable tokens_rawMonomialIdealClass;
extern tokens_HashTable tokens_rawMonoidClass;
extern tokens_HashTable tokens_rawMonomialOrderingClass;
extern tokens_HashTable tokens_rawMonomialClass;
extern tokens_HashTable tokens_rawObjectClass;
extern tokens_HashTable tokens_CCClass;
extern tokens_HashTable tokens_RRClass;
extern tokens_HashTable tokens_inexactNumberTypeClass;
extern tokens_HashTable tokens_ringFamilyClass;
extern tokens_HashTable tokens_QQClass;
extern tokens_HashTable tokens_ZZClass;
extern tokens_HashTable tokens_inexactNumberClass;
extern tokens_HashTable tokens_numberClass;
extern tokens_HashTable tokens_ringElementClass;
extern tokens_HashTable tokens_ringClass;
extern tokens_HashTable tokens_missingMethodClass;
extern tokens_HashTable tokens_errorMessageClass;
extern tokens_HashTable tokens_arrayClass;
extern tokens_HashTable tokens_sequenceClass;
extern tokens_HashTable tokens_listClass;
extern tokens_HashTable tokens_visibleListClass;
extern tokens_HashTable tokens_dbClass;
extern tokens_HashTable tokens_globalDictionaryClass;
extern tokens_HashTable tokens_localDictionaryClass;
extern tokens_HashTable tokens_dictionaryClass;
extern tokens_HashTable tokens_booleanClass;
extern tokens_HashTable tokens_stringClass;
extern tokens_HashTable tokens_netFileClass;
extern tokens_HashTable tokens_netClass;
extern tokens_HashTable tokens_errorClass;
extern tokens_HashTable tokens_compiledFunctionBodyClass;
extern tokens_HashTable tokens_functionBodyClass;
extern tokens_HashTable tokens_mysqlResultClass;
extern tokens_HashTable tokens_mysqlFieldClass;
extern tokens_HashTable tokens_mysqlConnectionClass;
extern tokens_HashTable tokens_codeClass;
extern tokens_HashTable tokens_keywordClass;
extern tokens_HashTable tokens_symbolClass;
extern tokens_HashTable tokens_compiledFunctionClosureClass;
extern tokens_HashTable tokens_compiledFunctionClass;
extern tokens_HashTable tokens_functionClosureClass;
extern tokens_HashTable tokens_functionClass;
extern tokens_HashTable tokens_fileClass;
extern tokens_HashTable tokens_optionTableClass;
extern tokens_HashTable tokens_optionClass;
extern tokens_HashTable tokens_timeClass;
extern tokens_HashTable tokens_mutableListClass;
extern tokens_HashTable tokens_basicListClass;
extern tokens_HashTable tokens_cacheTableClass;
extern tokens_HashTable tokens_typeClass;
extern tokens_HashTable tokens_mutableHashTableClass;
extern tokens_HashTable tokens_hashTableClass;
extern tokens_HashTable tokens_thingClass;
extern tokens_HashTable tokens_newHashTable(tokens_HashTable,tokens_HashTable);
extern void tokens_printWarningMessage(tokens_Token,M2_string);
extern void tokens_printErrorMessage_1(tokens_Token,M2_string);
extern stdiop_Position tokens_position(tokens_Token);
extern tokens_Error tokens_printError(tokens_Error);
extern void tokens_printIfError(tokens_Expr);
extern __thread char tokens_debuggingMode;
extern __thread char tokens_stopIfError;
extern char tokens_handleInterrupts;
extern tokens_Expr (*tokens_debuggerFun)(tokens_Frame,tokens_Code);
extern tokens_Expr tokens_cwd();
extern tokens_Expr tokens_buildErrorPacketErrno(M2_string,int);
extern tokens_Expr tokens_buildErrorPacket_1(stdiop_Position,M2_string);
extern tokens_Expr tokens_buildErrorPacket(M2_string);
extern M2_string tokens_steppingMessage;
extern M2_string tokens_alarmMessage;
extern M2_string tokens_interruptMessage;
extern M2_string tokens_unwindMessage;
extern M2_string tokens_throwMessage;
extern M2_string tokens_breakMessage;
extern M2_string tokens_stepMessageWithArg;
extern M2_string tokens_stepMessage;
extern M2_string tokens_continueMessageWithArg;
extern M2_string tokens_continueMessage;
extern M2_string tokens_returnMessage;
extern tokens_parseinfo tokens_parseWORD;
extern tokens_Token tokens_dummyToken;
extern tokens_CodeClosure tokens_dummyCodeClosure;
extern tokens_Code tokens_NullCode;
extern tokens_Code tokens_dummyCode;
extern tokens_Symbol tokens_dummySymbol;
extern tokens_KeyValuePair tokens_bucketEnd;
extern tokens_Expr tokens_emptySequenceE;
extern tokens_Expr tokens_dummyTernaryFun(tokens_Code,tokens_Code,tokens_Code);
extern tokens_Expr tokens_dummyBinaryFun(tokens_Code,tokens_Code);
extern tokens_Expr tokens_dummyPostfixFun(tokens_Code);
extern tokens_Expr tokens_dummyUnaryFun(tokens_Code);
extern tokens_Sequence tokens_emptySequence;
extern tokens_ParseTree tokens_dummyTree;
extern tokens_Word tokens_dummyWord;
extern tokens_parseinfo tokens_newParseinfo();
extern int tokens_nopr;
extern tokens_Frame tokens_emptyFrame;
extern tokens_DictionaryClosure tokens_newStaticLocalDictionaryClosure_1(tokens_DictionaryClosure);
extern tokens_DictionaryClosure tokens_newStaticLocalDictionaryClosure();
extern tokens_Frame tokens_newLocalFrame_1(tokens_Frame,tokens_Dictionary);
extern tokens_Frame tokens_newLocalFrame(tokens_Dictionary);
extern tokens_Dictionary tokens_emptyLocalDictionary;
extern tokens_Dictionary tokens_newStaticLocalDictionary();
extern tokens_Dictionary tokens_newLocalDictionary(tokens_Dictionary);
extern tokens_DictionaryClosure tokens_localDictionaryClosure(tokens_Frame);
extern tokens_Dictionary tokens_getLocalDictionary(int);
extern tokens_Dictionary tokens_dummyDictionary;
extern tokens_SymbolHashTable tokens_dummySymbolHashTable;
extern __thread tokens_Frame tokens_localFrame;
extern tokens_Dictionary tokens_newGlobalDictionary();
extern M2_ArrayString tokens_completions(M2_string);
extern tokens_Dictionary tokens_globalDictionary;
extern tokens_Dictionary tokens_Macaulay2Dictionary;
extern tokens_Expr tokens_getGlobalVariable(tokens_Symbol);
extern void tokens_setGlobalVariable(tokens_Symbol,tokens_Expr);
extern tokens_Frame tokens_enlargeThreadFrame();
extern int tokens_enlarge(tokens_Frame);
extern __thread tokens_Frame tokens_threadFrame;
extern int tokens_threadFramesize;
extern int tokens_threadFrameID;
extern tokens_Frame tokens_globalFrame;
extern tokens_Frame tokens_dummyFrame;
extern tokens_SymbolHashTable tokens_newSymbolHashTable();
extern tokens_Expr tokens_dummyExpr;
extern tokens_Expr tokens_notfoundE;
extern tokens_Expr tokens_nullE;
extern tokens_Expr tokens_toExpr(char);
extern tokens_Expr tokens_False;
extern tokens_Expr tokens_True;
extern char tokens_isInitialized(tokens_ThreadCell);
extern void tokens_printErrorMessage(tokens_Error);
extern tokens_Frame tokens_noRecycle(tokens_Frame);
extern tokens_functionDescription tokens_dummyDesc;
extern char tokens_isatty(tokens_TokenFile);
extern void tokens_clearFileError(tokens_TokenFile);
extern char tokens_fileError(tokens_TokenFile);
extern M2_string tokens_fileErrorMessage(tokens_TokenFile);
extern int tokens_close(tokens_TokenFile);
extern void tokens_flush(tokens_TokenFile);
extern char tokens_isglobaldict(tokens_Dictionary);
extern int tokens_dictionaryDepth(tokens_Dictionary);
extern int tokens_TCstring;
extern int tokens_TCRR;
extern int tokens_TCint;
extern int tokens_TCid;
extern int tokens_TCnone;
extern __thread int tokens_engineDebugLevel;
extern __thread int tokens_debugLevel;
extern void varnets__prepare() __attribute__ ((constructor));
extern struct M2_167 * varnets_tonets(varnets_NetFile);
extern nets_Net varnets_popnet(varnets_NetFile);
extern varnets_NetFile varnets_endlnetfile(varnets_NetFile);
extern varnets_NetFile varnets_less_less__6(varnets_NetFile,nets_Net);
extern varnets_NetFile varnets_less_less__5(varnets_NetFile,M2_string);
extern varnets_NetFile varnets_less_less__4(varnets_NetFile,int);
extern varnets_NetFile varnets_newNetFile();
extern int varnets_hash_2(varnets_NetFile);
extern int varnets_hash_1(varnets_vaNet);
extern varnets_vaNet varnets_less_less__3(varnets_vaNet,nets_Net);
extern varnets_vaNet varnets_newvaNet_1();
extern varnets_vaNet varnets_newvaNet(int);
extern struct M2_167 * varnets_toarray(varnets_vaNet);
extern varnets_varnet varnets_less_less__2(varnets_varnet,int);
extern varnets_varnet varnets_less_less__1(varnets_varnet,nets_Net);
extern varnets_varnet varnets_less_less_(varnets_varnet,M2_string);
extern nets_Net varnets_toNet(varnets_varnet);
extern varnets_varnet varnets_newvarnet();
extern int varnets_hash(varnets_varnet);
extern void engine__prepare() __attribute__ ((constructor));
extern unsigned long engine_hash(const struct Monomial *);
extern M2_string engine_tostring(const struct Monomial *);
extern engine_RawMonomialIdealOrNull engine_star__8(const struct MonomialIdeal *,const struct MonomialIdeal *);
extern engine_RawMonomialIdealOrNull engine_minus__6(const struct MonomialIdeal *,const struct MonomialIdeal *);
extern engine_RawMonomialIdealOrNull engine_plus__3(const struct MonomialIdeal *,const struct MonomialIdeal *);
extern engine_RawMutableMatrixOrNull engine_star__7(struct MutableMatrix *,struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_star__6(const struct Matrix *,const struct Matrix *);
extern engine_RawMutableMatrixOrNull engine_star__5(struct MutableMatrix *,const struct RingElement *);
extern engine_RawMutableMatrixOrNull engine_star__4(const struct RingElement *,struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_star__3(const struct Matrix *,const struct RingElement *);
extern engine_RawMatrixOrNull engine_star__2(const struct RingElement *,const struct Matrix *);
extern engine_RawMutableMatrixOrNull engine_minus__5(struct MutableMatrix *,struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_minus__4(const struct Matrix *,const struct Matrix *);
extern struct MutableMatrix * engine_minus__3(struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_minus__2(const struct Matrix *);
extern engine_RawMutableMatrixOrNull engine_plus__2(struct MutableMatrix *,struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_plus__1(const struct Matrix *,const struct Matrix *);
extern engine_RawRingElementOrNull engine_circ__1(const struct RingElement *,__mpz_struct *);
extern engine_RawRingElementOrNull engine_pct_(const struct RingElement *,const struct RingElement *);
extern engine_RawRingElementOrNull engine_slash_slash_(const struct RingElement *,const struct RingElement *);
extern engine_RawRingElementOrNull engine_star__1(const struct RingElement *,const struct RingElement *);
extern engine_RawRingElementOrNull engine_minus__1(const struct RingElement *,const struct RingElement *);
extern const struct RingElement * engine_minus_(const struct RingElement *);
extern engine_RawRingElementOrNull engine_plus_(const struct RingElement *,const struct RingElement *);
extern engine_RawMonomialOrNull engine_slash_(const struct Monomial *,const struct Monomial *);
extern engine_RawMonomialOrNull engine_circ_(const struct Monomial *,int);
extern engine_RawMonomialOrNull engine_star_(const struct Monomial *,const struct Monomial *);
extern M2_string engine_EngineError(M2_string);
extern void xml__prepare() __attribute__ ((constructor));
extern M2_string xml_DocDump(xmlNode *);
extern M2_string xml_toString(xmlNode *);
extern xmlNode * xml_AddText(xmlNode *,M2_string);
extern xmlNode * xml_AddElement(xmlNode *,M2_string);
extern xmlAttr * xml_AddAttribute(xmlNode *,M2_string,M2_string);
extern xmlNode * xml_NewRoot(M2_string,M2_string);
extern void xml_examine(xmlNode *);
extern xml_xmlNodeOrNull xml_Parse(M2_string);
extern void gmp__prepare() __attribute__ ((constructor));
extern gmp_CC gmp_circ__14(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_circ__13(gmp_CC,__mpz_struct *);
extern gmp_CC gmp_circ__12(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_circ__11(gmp_CC,gmp_CC);
extern gmp_CC gmp_atan_1(gmp_CC);
extern __mpfr_struct * gmp_abs2(gmp_CC);
extern gmp_CC gmp_asin_1(gmp_CC);
extern gmp_CC gmp_acos_1(gmp_CC);
extern gmp_CC gmp_csch_1(gmp_CC);
extern gmp_CC gmp_sech_1(gmp_CC);
extern gmp_CC gmp_coth_1(gmp_CC);
extern gmp_CC gmp_tanh_1(gmp_CC);
extern gmp_CC gmp_sinh_1(gmp_CC);
extern gmp_CC gmp_cosh_1(gmp_CC);
extern gmp_CC gmp_sec_1(gmp_CC);
extern gmp_CC gmp_csc_1(gmp_CC);
extern gmp_CC gmp_tan_1(gmp_CC);
extern gmp_CC gmp_cot_1(gmp_CC);
extern gmp_CC gmp_sin_1(gmp_CC);
extern gmp_CC gmp_cos_1(gmp_CC);
extern gmp_CC gmp_agm_1(gmp_CC,gmp_CC);
extern gmp_CC gmp_log_5(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_log_4(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_log_3(gmp_CC,gmp_CC);
extern gmp_CC gmp_logc_1(__mpfr_struct *,__mpfr_struct *);
extern gmp_CC gmp_logc(__mpfr_struct *);
extern gmp_CC gmp_log_2(gmp_CC);
extern gmp_CC gmp_exp_1(gmp_CC);
extern M2_string gmp_toExternalString_1(gmp_CC);
extern M2_string gmp_tonetCCparen(gmp_CC);
extern M2_string gmp_tonetCC(gmp_CC);
extern M2_string gmp_tostringCC(gmp_CC);
extern M2_string gmp_format_1(int,int,int,int,M2_string,char,char,gmp_CC);
extern M2_string gmp_toExternalString(__mpfr_struct *);
extern M2_string gmp_tostringRR(__mpfr_struct *);
extern M2_string gmp_printingSeparator;
extern int gmp_printingTrailLimit;
extern int gmp_printingLeadLimit;
extern int gmp_printingAccuracy;
extern int gmp_printingPrecision;
extern M2_ArrayString gmp_format(int,int,int,int,M2_string,__mpfr_struct *);
extern char gmp_sign(__mpfr_struct *);
extern __mpfr_struct * gmp_yn(long,__mpfr_struct *);
extern __mpfr_struct * gmp_y1(__mpfr_struct *);
extern __mpfr_struct * gmp_y0(__mpfr_struct *);
extern __mpfr_struct * gmp_jn(long,__mpfr_struct *);
extern __mpfr_struct * gmp_j1(__mpfr_struct *);
extern __mpfr_struct * gmp_j0(__mpfr_struct *);
extern __mpfr_struct * gmp_erfc(__mpfr_struct *);
extern __mpfr_struct * gmp_erf(__mpfr_struct *);
extern __mpfr_struct * gmp_zeta_1(unsigned long,unsigned long);
extern __mpfr_struct * gmp_zeta(__mpfr_struct *);
extern __mpfr_struct * gmp_eint(__mpfr_struct *);
extern __mpfr_struct * gmp_factorial_1(__mpfr_struct *);
extern __mpfr_struct * gmp_Gamma(__mpfr_struct *);
extern __mpfr_struct * gmp_expm1(__mpfr_struct *);
extern __mpfr_struct * gmp_log1p(__mpfr_struct *);
extern __mpz_struct * gmp_factorial(unsigned long);
extern __mpfr_struct * gmp_coth(__mpfr_struct *);
extern __mpfr_struct * gmp_csch(__mpfr_struct *);
extern __mpfr_struct * gmp_sech(__mpfr_struct *);
extern __mpfr_struct * gmp_cot(__mpfr_struct *);
extern __mpfr_struct * gmp_csc(__mpfr_struct *);
extern __mpfr_struct * gmp_sec(__mpfr_struct *);
extern __mpfr_struct * gmp_tanh(__mpfr_struct *);
extern __mpfr_struct * gmp_cosh(__mpfr_struct *);
extern __mpfr_struct * gmp_sinh(__mpfr_struct *);
extern __mpfr_struct * gmp_agm(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_atan2(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_atan(__mpfr_struct *);
extern __mpfr_struct * gmp_acos(__mpfr_struct *);
extern __mpfr_struct * gmp_asin(__mpfr_struct *);
extern __mpfr_struct * gmp_tan(__mpfr_struct *);
extern __mpfr_struct * gmp_cos(__mpfr_struct *);
extern __mpfr_struct * gmp_sin(__mpfr_struct *);
extern __mpfr_struct * gmp_log_1(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_log(__mpfr_struct *);
extern __mpfr_struct * gmp_exp(__mpfr_struct *);
extern __mpfr_struct * gmp_pi(unsigned long);
extern gmp_CC gmp_sqrt_1(gmp_CC);
extern __mpfr_struct * gmp_abs_3(gmp_CC);
extern int gmp_compare_15(__mpq_struct *,gmp_CC);
extern int gmp_compare_14(gmp_CC,__mpq_struct *);
extern int gmp_compare_13(__mpz_struct *,gmp_CC);
extern int gmp_compare_12(gmp_CC,__mpz_struct *);
extern int gmp_compare_11(__mpfr_struct *,gmp_CC);
extern int gmp_compare_10(gmp_CC,__mpfr_struct *);
extern int gmp_compare_9(gmp_CC,gmp_CC);
extern char gmp_equal_equal_equal__23(__mpq_struct *,gmp_CC);
extern char gmp_equal_equal_equal__22(gmp_CC,__mpq_struct *);
extern char gmp_equal_equal_equal__21(__mpz_struct *,gmp_CC);
extern char gmp_equal_equal_equal__20(gmp_CC,__mpz_struct *);
extern char gmp_equal_equal_equal__19(__mpfr_struct *,gmp_CC);
extern char gmp_equal_equal_equal__18(gmp_CC,__mpfr_struct *);
extern char gmp_equal_equal_equal__17(gmp_CC,gmp_CC);
extern char gmp_strictequality_1(gmp_CC,gmp_CC);
extern gmp_CC gmp_slash__20(int,gmp_CC);
extern gmp_CC gmp_slash__19(__mpz_struct *,gmp_CC);
extern gmp_CC gmp_slash__18(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_slash__17(gmp_CC,gmp_CC);
extern gmp_CC gmp_inverse(gmp_CC);
extern gmp_CC gmp_greater_greater__4(gmp_CC,int);
extern gmp_CC gmp_less_less__7(gmp_CC,int);
extern gmp_CC gmp_greater_greater__3(gmp_CC,long);
extern gmp_CC gmp_less_less__6(gmp_CC,long);
extern __mpfr_struct * gmp_norm2(gmp_CC);
extern gmp_CC gmp_conj(gmp_CC);
extern gmp_CC gmp_slash__16(gmp_CC,int);
extern gmp_CC gmp_slash__15(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_star__25(gmp_CC,gmp_CC);
extern gmp_CC gmp_star__24(__mpz_struct *,gmp_CC);
extern gmp_CC gmp_star__23(gmp_CC,__mpz_struct *);
extern gmp_CC gmp_star__22(int,gmp_CC);
extern gmp_CC gmp_star__21(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_star__20(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_minus__24(gmp_CC);
extern gmp_CC gmp_plus__20(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_plus__19(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_minus__23(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_minus__22(int,gmp_CC);
extern gmp_CC gmp_minus__21(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_minus__20(gmp_CC,gmp_CC);
extern gmp_CC gmp_plus__18(gmp_CC,gmp_CC);
extern __mpfr_struct * gmp_greater_greater__2(__mpfr_struct *,int);
extern __mpfr_struct * gmp_less_less__5(__mpfr_struct *,int);
extern __mpfr_struct * gmp_greater_greater__1(__mpfr_struct *,long);
extern __mpfr_struct * gmp_less_less__4(__mpfr_struct *,long);
extern __mpz_struct * gmp_round(__mpfr_struct *);
extern __mpz_struct * gmp_ceil(__mpfr_struct *);
extern __mpz_struct * gmp_floor_1(__mpfr_struct *);
extern __mpfr_struct * gmp_circ__10(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_circ__9(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_circ__8(unsigned long,__mpfr_struct *);
extern __mpfr_struct * gmp_pow10_2(int,unsigned long);
extern __mpfr_struct * gmp_pow10_1(long,unsigned long);
extern __mpfr_struct * gmp_pow10(unsigned long,unsigned long);
extern __mpfr_struct * gmp_circ__7(__mpfr_struct *,unsigned long);
extern __mpfr_struct * gmp_circ__6(__mpfr_struct *,long);
extern __mpfr_struct * gmp_sqrt(__mpfr_struct *);
extern __mpfr_struct * gmp_slash__14(__mpfr_struct *,__mpq_struct *);
extern __mpfr_struct * gmp_slash__13(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_slash__12(__mpfr_struct *,int);
extern __mpfr_struct * gmp_slash__11(__mpfr_struct *,long);
extern __mpfr_struct * gmp_slash__10(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_star__19(__mpfr_struct *,__mpq_struct *);
extern __mpfr_struct * gmp_star__18(int,__mpfr_struct *);
extern __mpfr_struct * gmp_star__17(__mpfr_struct *,int);
extern __mpfr_struct * gmp_star__16(__mpz_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_star__15(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_star__14(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_abs_2(__mpfr_struct *);
extern __mpfr_struct * gmp_minus__19(__mpfr_struct *,__mpq_struct *);
extern __mpfr_struct * gmp_minus__18(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_minus__17(int,__mpfr_struct *);
extern __mpfr_struct * gmp_minus__16(__mpfr_struct *,int);
extern __mpfr_struct * gmp_minus__15(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_minus__14(__mpfr_struct *);
extern __mpfr_struct * gmp_plus__17(__mpfr_struct *,__mpq_struct *);
extern __mpfr_struct * gmp_plus__16(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_plus__15(__mpfr_struct *,int);
extern __mpfr_struct * gmp_plus__14(__mpfr_struct *,__mpfr_struct *);
extern int gmp_hash_3(gmp_CC);
extern int gmp_hash_2(__mpfr_struct *);
extern char gmp_less_equal__16(__mpfr_struct *,__mpq_struct *);
extern char gmp_less__16(__mpfr_struct *,__mpq_struct *);
extern char gmp_equal_equal_equal__16(__mpq_struct *,__mpfr_struct *);
extern char gmp_equal_equal_equal__15(__mpfr_struct *,__mpq_struct *);
extern char gmp_greater_equal__16(__mpfr_struct *,__mpq_struct *);
extern char gmp_greater__16(__mpfr_struct *,__mpq_struct *);
extern int gmp_compare_8(__mpq_struct *,__mpfr_struct *);
extern int gmp_compare_7(__mpfr_struct *,__mpq_struct *);
extern char gmp_less_equal__15(__mpfr_struct *,__mpz_struct *);
extern char gmp_less__15(__mpfr_struct *,__mpz_struct *);
extern char gmp_equal_equal_equal__14(__mpz_struct *,__mpfr_struct *);
extern char gmp_equal_equal_equal__13(__mpfr_struct *,__mpz_struct *);
extern char gmp_greater_equal__15(__mpfr_struct *,__mpz_struct *);
extern char gmp_greater__15(__mpfr_struct *,__mpz_struct *);
extern int gmp_compare_6(__mpz_struct *,__mpfr_struct *);
extern int gmp_compare_5(__mpfr_struct *,__mpz_struct *);
extern char gmp_less_equal__14(__mpfr_struct *,double);
extern char gmp_less__14(__mpfr_struct *,double);
extern char gmp_equal_equal_equal__12(__mpfr_struct *,double);
extern char gmp_greater_equal__14(__mpfr_struct *,double);
extern char gmp_greater__14(__mpfr_struct *,double);
extern int gmp_compare_4(double,__mpfr_struct *);
extern int gmp_compare_3(__mpfr_struct *,double);
extern char gmp_equal_equal_equal__11(gmp_CC,int);
extern char gmp_less_equal__13(__mpfr_struct *,int);
extern char gmp_less__13(__mpfr_struct *,int);
extern char gmp_equal_equal_equal__10(__mpfr_struct *,int);
extern char gmp_greater_equal__13(__mpfr_struct *,int);
extern char gmp_greater__13(__mpfr_struct *,int);
extern int gmp_compare_2(long,__mpfr_struct *);
extern int gmp_compare_1(__mpfr_struct *,long);
extern char gmp_less_equal__12(__mpfr_struct *,__mpfr_struct *);
extern char gmp_greater_equal__12(__mpfr_struct *,__mpfr_struct *);
extern char gmp_less__12(__mpfr_struct *,__mpfr_struct *);
extern char gmp_greater__12(__mpfr_struct *,__mpfr_struct *);
extern int gmp_compare(__mpfr_struct *,__mpfr_struct *);
extern char gmp_strictequality(__mpfr_struct *,__mpfr_struct *);
extern char gmp_equal_equal_equal__9(__mpfr_struct *,__mpfr_struct *);
extern char gmp_isnan_1(gmp_CC);
extern char gmp_isinf_1(gmp_CC);
extern char gmp_isfinite_1(gmp_CC);
extern char gmp_isnan(__mpfr_struct *);
extern char gmp_isinf(__mpfr_struct *);
extern char gmp_isfinite(__mpfr_struct *);
extern char gmp_flagged();
extern double gmp_toDouble_4(gmp_RRcell);
extern double gmp_toDouble_3(__mpfr_struct *);
extern gmp_CC gmp_toCC_14(double,double,unsigned long);
extern gmp_CC gmp_toCC_13(double,unsigned long);
extern gmp_CC gmp_toCC_12(unsigned long,unsigned long);
extern gmp_CC gmp_toCC_11(int,int,unsigned long);
extern gmp_CC gmp_toCC_10(int,unsigned long);
extern gmp_CC gmp_toCC_9(__mpz_struct *);
extern gmp_CC gmp_toCC_8(__mpq_struct *);
extern gmp_CC gmp_toCC_7(__mpz_struct *,unsigned long);
extern gmp_CC gmp_toCC_6(__mpq_struct *,unsigned long);
extern gmp_CC gmp_toCC_5(__mpfr_struct *,__mpfr_struct *,unsigned long);
extern gmp_CC gmp_toCC_4(gmp_CC,unsigned long);
extern gmp_CC gmp_toCC_3(__mpfr_struct *,unsigned long);
extern gmp_CC gmp_toCC_2(int,__mpfr_struct *);
extern gmp_CC gmp_toCC_1(__mpfr_struct *);
extern gmp_CC gmp_nanCC(unsigned long);
extern gmp_CC gmp_infinityCC(unsigned long);
extern gmp_CC gmp_toCC(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_nanRR(unsigned long);
extern __mpfr_struct * gmp_infinityRR_1(unsigned long);
extern __mpfr_struct * gmp_infinityRR(unsigned long,int);
extern __mpfr_struct * gmp_toRR_9(double);
extern __mpfr_struct * gmp_toRR_8(double,unsigned long);
extern __mpfr_struct * gmp_toRR_7(unsigned long,unsigned long);
extern __mpfr_struct * gmp_toRR_6(int,unsigned long);
extern __mpfr_struct * gmp_toRR_5(__mpz_struct *);
extern __mpfr_struct * gmp_toRR_4(__mpz_struct *,unsigned long);
extern __mpfr_struct * gmp_toRR_3(__mpq_struct *);
extern __mpfr_struct * gmp_toRR_2(__mpq_struct *,unsigned long);
extern __mpfr_struct * gmp_toRR_1(M2_string,unsigned long);
extern __mpfr_struct * gmp_toRR(__mpfr_struct *,unsigned long);
extern unsigned long gmp_precision_1(gmp_CC);
extern unsigned long gmp_precision(__mpfr_struct *);
extern gmp_CC gmp_newCC(unsigned long);
extern __mpfr_struct * gmp_newRR(unsigned long);
extern long gmp_exponent_2(gmp_CC);
extern long gmp_exponent_1(__mpfr_struct *);
extern long gmp_exponent(__mpz_struct *);
extern long gmp_maxExponent;
extern long gmp_minExponent;
extern unsigned long gmp_maxprec;
extern unsigned long gmp_minprec;
extern unsigned long gmp_defaultPrecision;
extern char gmp_isZero_2(gmp_CC);
extern char gmp_isZero_1(__mpfr_struct *);
extern char gmp_isNegative_2(__mpfr_struct *);
extern char gmp_isPositive_1(__mpfr_struct *);
extern __mpfr_struct * gmp_imaginaryPart(gmp_CC);
extern __mpfr_struct * gmp_realPart(gmp_CC);
extern char gmp_greater_equal__11(__mpq_struct *,double);
extern char gmp_greater__11(__mpq_struct *,double);
extern char gmp_less_equal__11(__mpq_struct *,double);
extern char gmp_less__11(__mpq_struct *,double);
extern char gmp_greater_equal__10(double,__mpq_struct *);
extern char gmp_greater__10(double,__mpq_struct *);
extern char gmp_less_equal__10(double,__mpq_struct *);
extern char gmp_less__10(double,__mpq_struct *);
extern double gmp_slash__9(__mpq_struct *,double);
extern double gmp_star__13(__mpq_struct *,double);
extern double gmp_minus__13(__mpq_struct *,double);
extern double gmp_plus__13(__mpq_struct *,double);
extern double gmp_slash__8(double,__mpq_struct *);
extern double gmp_star__12(double,__mpq_struct *);
extern double gmp_minus__12(double,__mpq_struct *);
extern double gmp_plus__12(double,__mpq_struct *);
extern double gmp_toDouble_2(__mpq_struct *);
extern char gmp_greater_equal__9(int,__mpq_struct *);
extern char gmp_greater__9(int,__mpq_struct *);
extern char gmp_less_equal__9(int,__mpq_struct *);
extern char gmp_less__9(int,__mpq_struct *);
extern char gmp_less_equal__8(__mpq_struct *,int);
extern char gmp_greater__8(__mpq_struct *,int);
extern char gmp_greater_equal__8(__mpq_struct *,int);
extern char gmp_less__8(__mpq_struct *,int);
extern char gmp_greater_equal__7(__mpq_struct *,__mpz_struct *);
extern char gmp_greater__7(__mpq_struct *,__mpz_struct *);
extern char gmp_less_equal__7(__mpq_struct *,__mpz_struct *);
extern char gmp_less__7(__mpq_struct *,__mpz_struct *);
extern char gmp_greater_equal__6(__mpz_struct *,__mpq_struct *);
extern char gmp_greater__6(__mpz_struct *,__mpq_struct *);
extern char gmp_less_equal__6(__mpz_struct *,__mpq_struct *);
extern char gmp_less__6(__mpz_struct *,__mpq_struct *);
extern char gmp_less_equal__5(__mpq_struct *,__mpq_struct *);
extern char gmp_greater__5(__mpq_struct *,__mpq_struct *);
extern char gmp_greater_equal__5(__mpq_struct *,__mpq_struct *);
extern char gmp_less__5(__mpq_struct *,__mpq_struct *);
extern char gmp_equal_equal_equal__8(int,__mpq_struct *);
extern char gmp_equal_equal_equal__7(__mpz_struct *,__mpq_struct *);
extern char gmp_equal_equal_equal__6(__mpq_struct *,int);
extern char gmp_equal_equal_equal__5(__mpq_struct *,__mpz_struct *);
extern stdio_file gmp_less_less__3(stdio_file,__mpq_struct *);
extern M2_string gmp_tostring_1(__mpq_struct *);
extern __mpq_struct * gmp_circ__5(__mpq_struct *,__mpz_struct *);
extern __mpq_struct * gmp_slash__7(int,__mpq_struct *);
extern __mpq_struct * gmp_slash__6(__mpz_struct *,__mpq_struct *);
extern __mpq_struct * gmp_slash__5(__mpq_struct *,int);
extern __mpq_struct * gmp_slash__4(__mpq_struct *,__mpz_struct *);
extern __mpq_struct * gmp_slash__3(__mpz_struct *,__mpz_struct *);
extern __mpq_struct * gmp_star__11(int,__mpq_struct *);
extern __mpq_struct * gmp_star__10(__mpz_struct *,__mpq_struct *);
extern __mpq_struct * gmp_star__9(__mpq_struct *,int);
extern __mpq_struct * gmp_star__8(__mpq_struct *,__mpz_struct *);
extern __mpq_struct * gmp_minus__11(int,__mpq_struct *);
extern __mpq_struct * gmp_minus__10(__mpz_struct *,__mpq_struct *);
extern __mpq_struct * gmp_minus__9(__mpq_struct *,int);
extern __mpq_struct * gmp_minus__8(__mpq_struct *,__mpz_struct *);
extern __mpq_struct * gmp_plus__11(int,__mpq_struct *);
extern __mpq_struct * gmp_plus__10(__mpz_struct *,__mpq_struct *);
extern __mpq_struct * gmp_plus__9(__mpq_struct *,int);
extern __mpq_struct * gmp_plus__8(__mpq_struct *,__mpz_struct *);
extern char gmp_equal_equal_equal__4(__mpq_struct *,__mpq_struct *);
extern __mpq_struct * gmp_slash__2(__mpq_struct *,__mpq_struct *);
extern __mpq_struct * gmp_star__7(__mpq_struct *,__mpq_struct *);
extern __mpq_struct * gmp_minus__7(__mpq_struct *,__mpq_struct *);
extern __mpq_struct * gmp_inv(__mpq_struct *);
extern __mpq_struct * gmp_abs_1(__mpq_struct *);
extern __mpq_struct * gmp_minus__6(__mpq_struct *);
extern __mpq_struct * gmp_plus__7(__mpq_struct *,__mpq_struct *);
extern __mpz_struct * gmp_floor(__mpq_struct *);
extern __mpq_struct * gmp_toRational_2(__mpz_struct *);
extern __mpq_struct * gmp_toRational_1(unsigned long);
extern __mpq_struct * gmp_toRational(int);
extern __mpq_struct * gmp_newRationalCanonical(__mpz_struct *,__mpz_struct *);
extern __mpq_struct * gmp_newRational(__mpz_struct *,__mpz_struct *);
extern char gmp_isNegative_1(__mpq_struct *);
extern int gmp_hash_1(__mpq_struct *);
extern __mpz_struct * gmp_denominator(__mpq_struct *);
extern __mpz_struct * gmp_numerator(__mpq_struct *);
extern char gmp_greater_equal__4(double,__mpz_struct *);
extern char gmp_less_equal__4(double,__mpz_struct *);
extern char gmp_greater__4(double,__mpz_struct *);
extern char gmp_less__4(double,__mpz_struct *);
extern char gmp_less_equal__3(__mpz_struct *,double);
extern char gmp_greater_equal__3(__mpz_struct *,double);
extern char gmp_less__3(__mpz_struct *,double);
extern char gmp_greater__3(__mpz_struct *,double);
extern double gmp_circ__4(double,__mpz_struct *);
extern double gmp_slash__1(__mpz_struct *,double);
extern double gmp_slash_(double,__mpz_struct *);
extern double gmp_star__6(__mpz_struct *,double);
extern double gmp_star__5(double,__mpz_struct *);
extern double gmp_minus__5(__mpz_struct *,double);
extern double gmp_minus__4(double,__mpz_struct *);
extern double gmp_plus__6(__mpz_struct *,double);
extern double gmp_plus__5(double,__mpz_struct *);
extern double gmp_toDouble_1(gmp_ZZcell);
extern double gmp_toDouble(__mpz_struct *);
extern stdio_file gmp_less_less__2(stdio_file,__mpz_struct *);
extern __mpz_struct * gmp_circ__3(int,unsigned long);
extern __mpz_struct * gmp_star__4(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_star__3(unsigned long,__mpz_struct *);
extern __mpz_struct * gmp_star__2(__mpz_struct *,int);
extern __mpz_struct * gmp_star__1(int,__mpz_struct *);
extern __mpz_struct * gmp_minus__3(__mpz_struct *,int);
extern __mpz_struct * gmp_minus__2(int,__mpz_struct *);
extern __mpz_struct * gmp_plus__4(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_plus__3(unsigned long,__mpz_struct *);
extern __mpz_struct * gmp_plus__2(__mpz_struct *,int);
extern __mpz_struct * gmp_plus__1(int,__mpz_struct *);
extern M2_string gmp_tostring(__mpz_struct *);
extern __mpz_struct * gmp_circ_circ_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_or_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_amp_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_greater_greater_(__mpz_struct *,int);
extern __mpz_struct * gmp_less_less__1(__mpz_struct *,int);
extern __mpz_struct * gmp_gcd(__mpz_struct *,__mpz_struct *);
extern unsigned short gmp_pct__2(__mpz_struct *,unsigned short);
extern unsigned long gmp_pct__1(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_slash_slash__2(__mpz_struct *,unsigned short);
extern __mpz_struct * gmp_slash_slash__1(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_pct_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_slash_slash_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_powermod(__mpz_struct *,__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_circ__2(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_circ__1(__mpz_struct *,int);
extern __mpz_struct * gmp_circ_(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_star_(__mpz_struct *,__mpz_struct *);
extern char gmp_equal_equal_equal__3(int,__mpz_struct *);
extern char gmp_greater_equal__2(int,__mpz_struct *);
extern char gmp_less_equal__2(int,__mpz_struct *);
extern char gmp_greater__2(int,__mpz_struct *);
extern char gmp_less__2(int,__mpz_struct *);
extern char gmp_less_equal__1(__mpz_struct *,int);
extern char gmp_less__1(__mpz_struct *,int);
extern char gmp_equal_equal_equal__2(gmp_ZZcell,int);
extern char gmp_equal_equal_equal__1(__mpz_struct *,int);
extern char gmp_greater_equal__1(__mpz_struct *,int);
extern char gmp_greater__1(__mpz_struct *,int);
extern char gmp_less_equal_(__mpz_struct *,__mpz_struct *);
extern char gmp_greater_equal_(__mpz_struct *,__mpz_struct *);
extern char gmp_less_(__mpz_struct *,__mpz_struct *);
extern char gmp_greater_(__mpz_struct *,__mpz_struct *);
extern char gmp_equal_equal_equal_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_minus__1(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_plus_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_abs(__mpz_struct *);
extern __mpz_struct * gmp_minus_(__mpz_struct *);
extern __mpz_struct * gmp_toInteger_3(long);
extern __mpz_struct * gmp_toInteger_2(unsigned long);
extern __mpz_struct * gmp_toInteger_1(unsigned short);
extern __mpz_struct * gmp_toInteger(int);
extern __mpz_struct * gmp_copy(__mpz_struct *);
extern __mpz_struct * gmp_newZZ();
extern int gmp_hash(__mpz_struct *);
extern unsigned long gmp_toULong_1(gmp_ZZcell);
extern unsigned long gmp_toULong(__mpz_struct *);
extern char gmp_isULong_1(gmp_ZZcell);
extern char gmp_isULong(__mpz_struct *);
extern long gmp_toLong_1(gmp_ZZcell);
extern long gmp_toLong(__mpz_struct *);
extern char gmp_isLong_1(gmp_ZZcell);
extern char gmp_isLong(__mpz_struct *);
extern int gmp_toInt_1(gmp_ZZcell);
extern int gmp_toInt(__mpz_struct *);
extern char gmp_isInt_1(gmp_ZZcell);
extern char gmp_isInt(__mpz_struct *);
extern unsigned short gmp_toUShort(__mpz_struct *);
extern char gmp_isUShort(__mpz_struct *);
extern char gmp_isOdd(__mpz_struct *);
extern char gmp_isEven(__mpz_struct *);
extern char gmp_isNegative(__mpz_struct *);
extern char gmp_isZero(__mpz_struct *);
extern char gmp_isPositive(__mpz_struct *);
extern stdio_file gmp_less_less_(stdio_file,M2_charstarOrNull);
extern unsigned long gmp_max_3(unsigned long,unsigned long);
extern unsigned long gmp_min_3(unsigned long,unsigned long);
extern long gmp_max_2(long,long);
extern long gmp_min_2(long,long);
extern unsigned int gmp_max_1(unsigned int,unsigned int);
extern unsigned int gmp_min_1(unsigned int,unsigned int);
extern int gmp_max(int,int);
extern int gmp_min(int,int);
extern M2_string (*gmp_tonetCCparenpointer)(gmp_CC);
extern M2_string (*gmp_tonetCCpointer)(gmp_CC);
extern M2_string (*gmp_tostringRRpointer)(__mpfr_struct *);
extern void err__prepare() __attribute__ ((constructor));
extern void err_less_less_(stdio_file,stdio_errmsg);
extern void err_syserr_1(stdio_errmsg);
extern void err_fatal_1(stdio_errmsg);
extern void err_error_1(stdio_errmsg);
extern void err_warning_1(stdio_errmsg);
extern void err_syserr(M2_string);
extern void err_abort(M2_string);
extern void err_fatal(M2_string);
extern void err_error(M2_string);
extern void err_warning(M2_string);
extern void stdiop__prepare() __attribute__ ((constructor));
extern void stdiop_flush(stdiop_PosFile);
extern int stdiop_getc(stdiop_PosFile);
extern struct tagged_union * stdiop_openPosIn(M2_string);
extern void stdiop_unsetprompt(stdiop_PosFile);
extern void stdiop_setprompt(stdiop_PosFile,M2_string (*)());
extern int stdiop_close(stdiop_PosFile);
extern char stdiop_isatty(stdiop_PosFile);
extern int stdiop_peek_1(stdiop_PosFile);
extern int stdiop_peek(stdiop_PosFile,int);
extern stdiop_PosFile stdiop_makePosFile(stdio_file);
extern M2_string stdiop_fileErrorMessage(stdiop_PosFile);
extern void stdiop_clearFileError(stdiop_PosFile);
extern char stdiop_fileError(stdiop_PosFile);
extern stdiop_PosFile stdiop_dummyPosFile;
extern stdiop_Position stdiop_position(stdiop_PosFile);
extern stdiop_Position stdiop_copy(stdiop_Position);
extern errio_BasicFile stdiop_less_less__3(errio_BasicFile,stdiop_Position);
extern stdio_file stdiop_less_less__2(stdio_file,stdiop_Position);
extern void stdiop_printErrorMessage_1(M2_string,unsigned short,unsigned short,M2_string);
extern void stdiop_printWarningMessage(stdiop_Position,M2_string);
extern void stdiop_printErrorMessage(stdiop_Position,M2_string);
extern __thread int stdiop_recursionLimit;
extern __thread int stdiop_recursionDepth;
extern __thread char stdiop_SuppressErrors;
extern errio_BasicFile stdiop_less_less__1(errio_BasicFile,stdiop_Position);
extern stdio_file stdiop_less_less_(stdio_file,stdiop_Position);
extern M2_string stdiop_tostring(stdiop_Position);
extern M2_string stdiop_verifyMinimizeFilename(M2_string);
extern M2_string stdiop_minimizeFilename(M2_string);
extern M2_string stdiop_relativizeFilename_1(M2_string);
extern M2_string stdiop_relativizeFilename(M2_string,M2_string);
extern stdiop_Position stdiop_dummyPosition;
extern char stdiop_equal_equal_equal_(stdiop_Position,stdiop_Position);
extern void stdio__prepare() __attribute__ ((constructor));
extern stdio_file stdio_less_less__15(stdio_file,unsigned long);
extern stdio_file stdio_less_less__14(stdio_file,long);
extern void stdio_endLine(stdio_file);
extern char stdio_atEndOfLine(stdio_file);
extern int stdio_fchmod(stdio_file,int);
extern int stdio_less_less__13(errio_BasicFile,stdio_Manipulator);
extern stdio_Manipulator stdio_Flush;
extern stdio_Manipulator stdio_endl;
extern stdio_file stdio_less_less__12(stdio_file,stdio_Manipulator);
extern stdio_StringOrError stdio_get(M2_string);
extern void stdio_clean(stdio_file);
extern void stdio_unsetprompt(stdio_file);
extern void stdio_setprompt(stdio_file,M2_string (*)());
extern stdio_file stdio_less_less__11(stdio_file,int,int);
extern stdio_file stdio_less_less__10(stdio_file,M2_string,int);
extern varstrin_varstring stdio_less_less__9(varstrin_varstring,int);
extern M2_string stdio_blanks(int);
extern int stdio_peek_1(stdio_file);
extern int stdio_peek(stdio_file,int);
extern stdio_StringOrError stdio_read(stdio_file);
extern int stdio_getc(stdio_file);
extern stdio_file stdio_less_less__8(stdio_file,double);
extern M2_string stdio_tostringRR(double);
extern M2_string stdio_tostring5(double,int,int,int,M2_string);
extern M2_string stdio_tostring_3(char);
extern char stdio_isnan(double);
extern char stdio_isinf(double);
extern char stdio_finite(double);
extern stdio_file stdio_less_less__7(stdio_file,char);
extern stdio_file stdio_less_less__6(stdio_file,unsigned char);
extern stdio_file stdio_less_less__5(stdio_file,unsigned short);
extern stdio_file stdio_less_less__4(stdio_file,short);
extern stdio_file stdio_less_less__3(stdio_file,int);
extern int stdio_filbuf(stdio_file);
extern M2_string stdio_presentn(M2_string);
extern M2_string stdio_present_1(M2_string);
extern M2_string stdio_present(char);
extern stdio_file stdio_less_less__2(stdio_file,M2_string);
extern stdio_file stdio_less_less__1(stdio_file,char);
extern stdio_file stdio_less_less_(stdio_file,nets_Net);
extern stdio_errmsg stdio_close(stdio_file);
extern stdio_errmsg stdio_closeOut(stdio_file);
extern stdio_errmsg stdio_closeIn(stdio_file);
extern stdio_errmsg stdio_closeListener(stdio_file);
extern int stdio_flush(stdio_file);
extern void stdio_flushinput(stdio_file);
extern struct tagged_union * stdio_openListener(M2_string);
extern struct tagged_union * stdio_openInOut_1(M2_string);
extern struct tagged_union * stdio_openOutAppend(M2_string);
extern struct tagged_union * stdio_openOut_1(M2_string);
extern struct tagged_union * stdio_openIn_1(M2_string);
extern M2_string stdio_expandFileName(M2_string);
extern struct tagged_union * stdio_openInOut(stdio_file);
extern struct tagged_union * stdio_openOut(stdio_file);
extern struct tagged_union * stdio_openIn(stdio_file);
extern stdio_FileCell stdio_openfiles;
extern int stdio_lineNumber;
extern int stdio_interpreterDepth;
extern M2_string stdio_tostring_2(unsigned long);
extern M2_string stdio_tostring_1(long);
extern M2_string stdio_tostring(int);
extern __thread stdio_file stdio_stdIO;
extern stdio_file stdio_dummyfile;
extern __thread stdio_file stdio_stdError;
extern M2_string stdio_noprompt();
extern M2_string stdio_fileErrorMessage_1(stdio_file);
extern void stdio_clearFileError(stdio_file);
extern char stdio_fileError(stdio_file);
extern M2_string stdio_fileErrorMessage(stdio_file,M2_string);
extern M2_string stdio_syscallErrorMessage(M2_string);
extern char stdio_iserror(int);
extern char stdio_iseof(int);
extern int stdio_nextHash();
extern void errio__prepare() __attribute__ ((constructor));
extern errio_BasicFile errio_less_less__7(errio_BasicFile,char);
extern errio_BasicFile errio_less_less__6(errio_BasicFile,unsigned char);
extern errio_BasicFile errio_less_less__5(errio_BasicFile,unsigned short);
extern errio_BasicFile errio_less_less__4(errio_BasicFile,short);
extern errio_BasicFile errio_less_less__3(errio_BasicFile,int);
extern errio_BasicManipulator errio_basicEndl;
extern errio_BasicManipulator errio_basicFlush;
extern int errio_less_less__2(errio_BasicFile,errio_BasicManipulator);
extern errio_BasicFile errio_less_less__1(errio_BasicFile,M2_string);
extern errio_BasicFile errio_less_less_(errio_BasicFile,char);
extern __thread errio_BasicFile errio_stderr;
extern void interrupts__prepare() __attribute__ ((constructor));
extern void interrupts_clearSteppingFlag();
extern int interrupts_microStepCount;
extern int interrupts_stepCount;
extern void interrupts_clearAlarmedFlag();
extern void interrupts_clearInterruptFlag();
extern void interrupts_setSteppingFlag();
extern void interrupts_setAlarmedFlag();
extern void interrupts_setInterruptFlag();
extern void interrupts_clearAllFlags();
extern void interrupts_clearAlarm();
extern void interrupts_determineExceptionFlag();
extern __thread struct atomic_field interrupts_exceptionFlag;
extern __thread struct atomic_field interrupts_interruptedFlag;
extern __thread char interrupts_steppingFlag;
extern __thread char interrupts_alarmedFlag;
extern __thread char interrupts_interruptPending;
extern __thread char interrupts_interruptShield;
extern void atomic__prepare() __attribute__ ((constructor));
extern void nets__prepare() __attribute__ ((constructor));
extern int nets_hash(nets_Net);
extern nets_Net nets_wrap(int,char,nets_Net);
extern void vararray__prepare() __attribute__ ((constructor));
extern M2_arrayint vararray_takereversearrayint(vararray_vararrayint);
extern M2_arrayint vararray_takearrayint(vararray_vararrayint);
extern void vararray_empty(vararray_vararrayint);
extern M2_arrayint vararray_toreversearrayint(vararray_vararrayint);
extern M2_arrayint vararray_toarrayint(vararray_vararrayint);
extern vararray_vararrayint vararray_less_less__1(vararray_vararrayint,M2_arrayint);
extern vararray_vararrayint vararray_less_less_(vararray_vararrayint,int);
extern vararray_vararrayint vararray_newvararrayint(int);
extern int nets_netcmp_2(M2_string,nets_Net);
extern int nets_netcmp_1(nets_Net,M2_string);
extern int nets_netcmp(nets_Net,nets_Net);
extern nets_NetList nets_dummyNetList;
extern nets_Net nets_dummyNet;
extern nets_Net nets_HorizontalJoin_1(nets_NetList);
extern char nets_equal_equal_equal_(nets_Net,nets_Net);
extern nets_Net nets_VerticalJoin(struct M2_167 *);
extern nets_Net nets_HorizontalJoin(struct M2_167 *);
extern nets_Net nets_RaiseNet(nets_Net,int);
extern nets_Net nets_toNet_1(char);
extern nets_Net nets_toNet(M2_string);
extern M2_ArrayString nets_lines(M2_string);
extern M2_string nets_toString(nets_Net);
extern void ctype__prepare() __attribute__ ((constructor));
extern char ctype_isalnum_2(M2_string);
extern char ctype_isquote_1(char);
extern char ctype_isnewline_1(char);
extern char ctype_isspace_1(char);
extern char ctype_iswhite_1(char);
extern char ctype_isalnum_1(char);
extern char ctype_isalpha_1(char);
extern char ctype_isbinary_1(char);
extern char ctype_ishex_1(char);
extern char ctype_isdigit_1(char);
extern char ctype_isquote(int);
extern char ctype_isnewline(int);
extern char ctype_isspace(int);
extern char ctype_iswhite(int);
extern char ctype_isalnum(int);
extern char ctype_isalpha(int);
extern char ctype_isbinary(int);
extern char ctype_ishex(int);
extern char ctype_isdigit(int);
extern void varstrin__prepare() __attribute__ ((constructor));
extern M2_ArrayString varstrin_extract(varstrin_varstringarray);
extern varstrin_varstringarray varstrin_append(varstrin_varstringarray,M2_string);
extern varstrin_varstringarray varstrin_newvarstringarray(int);
extern void varstrin_putdigit(varstrin_varstring,int);
extern int varstrin_hash(varstrin_varstring);
extern M2_string varstrin_takereversestring(varstrin_varstring);
extern M2_string varstrin_takestring(varstrin_varstring);
extern void varstrin_empty(varstrin_varstring);
extern M2_string varstrin_toreversestring(varstrin_varstring);
extern M2_string varstrin_tostring(varstrin_varstring);
extern varstrin_varstring varstrin_less_less__1(varstrin_varstring,M2_string);
extern varstrin_varstring varstrin_less_less_(varstrin_varstring,char);
extern void varstrin_blankfill(int,varstrin_varstring);
extern varstrin_varstring varstrin_newvarstring(int);
extern void strings__prepare() __attribute__ ((constructor));
extern int strings_index_3(M2_string,int,char,char);
extern int strings_index_2(M2_string,int,M2_string);
extern char strings_match(M2_string,int,M2_string);
extern int strings_index_1(M2_string,int,char);
extern int strings_index(M2_string,int);
extern int strings_hash(M2_string);
extern char strings_less_equal_(M2_string,M2_string);
extern char strings_greater_(M2_string,M2_string);
extern char strings_greater_equal_(M2_string,M2_string);
extern char strings_less_(M2_string,M2_string);
extern char strings_strchr(M2_string,char);
extern char strings_equal_equal_equal_(M2_string,M2_string);
extern M2_string strings_newstring(int);
extern M2_string strings_reverse(M2_string);
extern M2_string strings_plus__2(char,M2_string);
extern M2_string strings_plus__1(M2_string,char);
extern M2_string strings_plus_(M2_string,M2_string);
extern M2_string strings_between(M2_string,M2_ArrayString);
extern M2_string strings_concatenate(M2_ArrayString);
extern void system__prepare() __attribute__ ((constructor));
extern void system_everytimeRun();
extern void system_everytime(void (*)());
extern int system_hasException(int);
extern int system_isReady(int);
extern void system_segmentationFault();
extern void system_handleInterruptsSetup(char);
extern int system_chdir(M2_string);
extern M2_ArrayString system_history();
extern int system_strncmp(M2_string,M2_string,int);
extern M2_ArrayStringOrNull system_readDirectory(M2_string);
extern M2_ArrayString system_regexselect(M2_string,M2_string,M2_string,M2_ArrayString,char);
extern M2_string system_regexreplace(M2_string,M2_string,M2_string,M2_string,char);
extern M2_arrayint system_regexmatch(M2_string,int,int,M2_string,char);
extern M2_string system_regexmatchErrorMessage;
extern M2_string system_noErrorMessage;
extern M2_string system_realpath(M2_string);
extern M2_string system_readlink(M2_string);
extern M2_ArrayStringOrNull system_wordexp(M2_string);
extern int system_isRegularFile(M2_string);
extern int system_isDirectory(M2_string);
extern int system_rmdir(M2_string);
extern int system_mkdir(M2_string);
extern int system_fileModeFD(int);
extern int system_fileMode(M2_string);
extern int system_currentTime();
extern int system_setFileTime(M2_string,int);
extern int system_fileTime(M2_string);
extern char system_fileExists(M2_string);
extern int system_fileLength_1(M2_string);
extern int system_fileLength(int);
extern M2_string system_readfile(int);
extern M2_string system_dbmstrerror();
extern int system_dbmreorganize(int);
extern M2_string system_dbmnext(int);
extern M2_string system_dbmfirst(int);
extern int system_dbmdelete(int,M2_string);
extern M2_string system_dbmfetch(int,M2_string);
extern int system_chmod(M2_string,int);
extern int system_dbmstore(int,M2_string,M2_string);
extern int system_dbmclose(int);
extern M2_string system_dbmerror();
extern int system_dbmopen(M2_string,char);
extern __thread unsigned short system_loadDepth;
extern M2_string system_errfmt(M2_string,int,int,int);
extern int system_loaddata(int,M2_string);
extern int system_dumpdata(M2_string);
extern M2_string system_getcwd();
extern int system_hash(double);
extern M2_arrayint system_select(M2_arrayint);
extern M2_arrayint system_waitNoHang(M2_arrayint);
extern int system_wait(int);
extern int system_randomint();
extern int system_strnumcmp(M2_string,M2_string);
extern int system_strcmp(M2_string,M2_string);
extern double system_cpuTime();
extern M2_string system_getenv(M2_string);
extern int system_exec(M2_ArrayString);
extern int system_pipe(M2_arrayint);
extern int system_run(M2_string);
extern void system_atend(void (*)());
extern M2_string system_strerror_1(int);
extern const char * system_strerror();
extern M2_string system_syserrmsg();
extern int system_acceptNonblocking(int);
extern int system_acceptBlocking(int);
extern int system_openlistener(M2_string,M2_string);
extern int system_opensocket(M2_string,M2_string);
extern int system_openoutappend(M2_string);
extern int system_openout(M2_string);
extern int system_openin(M2_string);
extern int system_unlink(M2_string);
extern int system_symlink(M2_string,M2_string);
extern int system_fchmod(int,int);
extern int system_link(M2_string,M2_string);
extern int system_readline(M2_string,int,int,M2_string);
extern int system_read_1(int,M2_string,int,int);
extern int system_read(int,M2_string,int);
extern int system_write_2(int,M2_string,int,int);
extern int system_write_1(int,M2_string);
extern int system_write(int,M2_string,int);
extern void system_exit(int);
extern int system_setpgid(int,int);
extern int system_getpgrp();
extern int system_getpid();
extern int system_sleep(int);
extern void M2__prepare() __attribute__ ((constructor));
extern char M2_notify;
extern __thread int M2_gbTrace;
extern M2_ArrayString M2_args;
extern M2_ArrayString M2_argv;
extern M2_ArrayString M2_envp;
extern M2_string M2_newline;
extern M2_string M2_substrAlwaysCopy(M2_string,int,int);
extern M2_string M2_substr_1(M2_string,int);
extern M2_string M2_substr(M2_string,int,int);
extern M2_string M2_enlarge(int,M2_string);
extern M2_ArrayString M2_tostrings(int,char **);
extern char ** M2_tocharstarstarmalloc(M2_ArrayString);
extern char * M2_tocharstarmalloc(M2_string);
extern char ** M2_tocharstarstar(M2_ArrayString);
extern M2_string M2_join(M2_string,M2_string);
extern M2_string M2_tostringn(char *,int);
extern M2_charstarOrNull M2_tocharstarOrNull(M2_string);
extern char * M2_tocharstar(M2_string);
extern M2_arrayint M2_makearrayint(int);
extern M2_string M2_tostring_3(const char *);
extern M2_string M2_tostring_2(char *);
extern M2_string M2_tostring_1(M2_charstarOrNull);
extern M2_string M2_tostring(M2_constcharstarOrNull);
extern void arithmetic__prepare() __attribute__ ((constructor));
extern void pthread0__prepare() __attribute__ ((constructor));
extern pthread_mutex_t pthread0_newMutex;

#if defined(__cplusplus)
  }
#endif

#endif
