#ifndef engine_included
#define engine_included
 extern char newline[]; 
#include <M2/config.h>

    #ifndef _GNU_SOURCE
    #define _GNU_SOURCE
    #endif
    #include <unistd.h>
    #ifdef HAVE_SYSCALL_H
      #include <sys/syscall.h>
    #endif
    #include <math.h>


  #include <atomic_ops.h>
  struct atomic_field {
       AO_t field;
       const char dummy; /* to prevent assignment */
       };

  #define load_Field(x) AO_load(&x.field)
  #define test_Field(x) (load_Field(x) != 0)
  #define store_Field(x,val) AO_store(&x.field,val)

  

    #include <math.h>
    #include <gmp.h>
    #include <mpfr.h>

/* included from scc1.c*/

#ifdef __cplusplus
  #define BASECLASS : public our_new_delete
  #include "newdelete.hpp"
#else
  #define BASECLASS
#endif

#if defined(__cplusplus)
  extern "C" {
#endif

#ifndef SAFEC_EXPORTS
#define SAFEC_EXPORTS
#endif
#ifndef SAFEC_basic_typedefs_defined
#define SAFEC_basic_typedefs_defined
typedef char M2_bool;
struct tagged_union { unsigned short type_; };
#undef M2_basic_typedefs_defined
#endif

/* typedefs */
typedef struct M2_string_struct * M2_string;
typedef struct M2_arrayint_struct * M2_arrayint;
typedef M2_arrayint M2_arrayintOrNull;
typedef struct M2_stringCell_struct * M2_stringCell;
typedef struct M2_ArrayString_struct * M2_ArrayString;
typedef M2_ArrayString M2_ArrayStringOrNull;
typedef char * M2_charstar;
typedef unsigned char * M2_ucharstar;
typedef char ** M2_charstarstar;
typedef const char * M2_constcharstar;
typedef const unsigned char * M2_constucharstar;
typedef const char ** M2_constcharstarstar;
typedef char * M2_charstarOrNull;
typedef const char * M2_constcharstarOrNull;
typedef const unsigned char * M2_constucharstarOrNull;
typedef const char ** M2_constcharstarstarOrNull;
typedef struct varstrin_varstring_struct * varstrin_varstring;
typedef struct varstrin_varstringarray_struct * varstrin_varstringarray;
typedef struct nets_Net_struct * nets_Net;
typedef struct nets_NetList_struct * nets_NetList;
typedef struct vararray_vararrayint_struct * vararray_vararrayint;
typedef AO_TS_VAL_t atomic_LockValue;
typedef AO_TS_t atomic_LockField;
typedef struct atomic_field atomic_atomicField;
typedef struct atomic_field * atomic_atomicFieldPointer;
typedef struct atomic_field * atomic_atomicFieldPointerOrNull;
typedef varstrin_varstring errio_BasicFile;
typedef struct errio_BasicManipulator_struct * errio_BasicManipulator;
typedef struct stdio_file_struct * stdio_file;
typedef struct stdio_errmsg_struct * stdio_errmsg;
typedef struct stdio_FileCell_struct * stdio_FileCell;
typedef struct tagged_union * stdio_StringOrError;
typedef struct stdio_Manipulator_struct * stdio_Manipulator;
typedef __mpz_struct gmp_ZZstruct;
typedef __mpz_struct * gmp_ZZ;
typedef __mpz_struct * gmp_ZZorNull;
typedef struct gmp_ZZcell_struct * gmp_ZZcell;
typedef struct gmp_ZZpair_struct * gmp_ZZpair;
typedef gmp_ZZpair gmp_ZZpairOrNull;
typedef __mpq_struct gmp_QQstruct;
typedef __mpq_struct * gmp_QQ;
typedef __mpq_struct * gmp_QQorNull;
typedef struct gmp_QQcell_struct * gmp_QQcell;
typedef __mpfr_struct gmp_RRstruct;
typedef __mpfr_struct * gmp_RR;
typedef __mpfr_struct * gmp_RRorNull;
typedef struct gmp_RRcell_struct * gmp_RRcell;
typedef struct gmp_CC_struct * gmp_CC;
typedef gmp_CC gmp_CCorNull;
typedef struct gmp_CCcell_struct * gmp_CCcell;
typedef const struct Monomial * engine_RawMonomial;
typedef struct engine_RawMonomialArray_struct * engine_RawMonomialArray;
typedef const struct Monomial * engine_RawMonomialOrNull;
typedef const struct MonomialOrdering * engine_RawMonomialOrdering;
typedef const struct MonomialOrdering * engine_RawMonomialOrderingOrNull;
typedef const struct Monoid * engine_RawMonoid;
typedef const struct Monoid * engine_RawMonoidOrNull;
typedef const struct Ring * engine_RawRing;
typedef const struct RingMap * engine_RawRingMap;
typedef const struct Ring * engine_RawRingOrNull;
typedef const struct RingElement * engine_RawRingElement;
typedef const struct RingElement * engine_RawRingElementOrNull;
typedef const struct MonomialIdeal * engine_RawMonomialIdeal;
typedef const struct MonomialIdeal * engine_RawMonomialIdealOrNull;
typedef const struct FreeModule * engine_RawFreeModule;
typedef const struct FreeModule * engine_RawFreeModuleOrNull;
typedef const struct Matrix * engine_RawMatrix;
typedef const struct Matrix * engine_RawMatrixOrNull;
typedef struct StraightLineProgram * engine_RawStraightLineProgram;
typedef struct StraightLineProgram * engine_RawStraightLineProgramOrNull;
typedef struct PathTracker * engine_RawPathTracker;
typedef struct PathTracker * engine_RawPathTrackerOrNull;
typedef struct MutableMatrix * engine_RawMutableMatrix;
typedef struct MutableMatrix * engine_RawMutableMatrixOrNull;
typedef struct engine_RawMonomialOrderingArray_struct * engine_RawMonomialOrderingArray;
typedef struct engine_RawMatrixPair_struct * engine_RawMatrixPair;
typedef engine_RawMatrixPair engine_RawMatrixPairOrNull;
typedef struct engine_RawMatrixArray_struct * engine_RawMatrixArray;
typedef engine_RawMatrixArray engine_RawMatrixArrayOrNull;
typedef struct engine_RawRingElementArray_struct * engine_RawRingElementArray;
typedef engine_RawRingElementArray engine_RawRingElementArrayOrNull;
typedef struct engine_RawArrayPair_struct * engine_RawArrayPair;
typedef engine_RawArrayPair engine_RawArrayPairOrNull;
typedef struct engine_RawMonomialPair_struct * engine_RawMonomialPair;
typedef struct engine_RawRingElementPair_struct * engine_RawRingElementPair;
typedef engine_RawMonomialPair engine_RawMonomialPairOrNull;
typedef engine_RawRingElementPair engine_RawRingElementPairOrNull;
typedef struct engine_RawMatrixAndInt_struct * engine_RawMatrixAndInt;
typedef struct Computation * engine_RawComputation;
typedef struct Computation * engine_RawComputationOrNull;
typedef struct engine_RawComputationCell_struct * engine_RawComputationCell;
typedef struct engine_RawFreeModuleCell_struct * engine_RawFreeModuleCell;
typedef struct engine_RawMatrixCell_struct * engine_RawMatrixCell;
typedef struct engine_RawMonoidCell_struct * engine_RawMonoidCell;
typedef struct engine_RawMonomialCell_struct * engine_RawMonomialCell;
typedef struct engine_RawMonomialIdealCell_struct * engine_RawMonomialIdealCell;
typedef struct engine_RawMonomialOrderingCell_struct * engine_RawMonomialOrderingCell;
typedef struct engine_RawMutableMatrixCell_struct * engine_RawMutableMatrixCell;
typedef struct engine_RawStraightLineProgramCell_struct * engine_RawStraightLineProgramCell;
typedef struct engine_RawPathTrackerCell_struct * engine_RawPathTrackerCell;
typedef struct engine_RawRingCell_struct * engine_RawRingCell;
typedef struct engine_RawRingElementCell_struct * engine_RawRingElementCell;
typedef struct engine_RawRingMapCell_struct * engine_RawRingMapCell;
/* array types */
struct M2_string_struct {int len;char array[1];};
struct M2_arrayint_struct {int len;int array[1];};
struct M2_ArrayString_struct {int len;M2_string array[1];};
struct M2_153 {int len;nets_Net array[1];};
struct engine_RawMonomialArray_struct {int len;const struct Monomial * array[1];};
struct engine_RawMonomialOrderingArray_struct {int len;const struct MonomialOrdering * array[1];};
struct engine_RawMatrixArray_struct {int len;const struct Matrix * array[1];};
struct engine_RawRingElementArray_struct {int len;const struct RingElement * array[1];};
/* struct types */
struct M2_stringCell_struct BASECLASS {unsigned int type_;M2_string v;};
struct varstrin_varstring_struct BASECLASS {M2_string str;int width;};
struct varstrin_varstringarray_struct BASECLASS {M2_ArrayString a;int n;};
struct nets_Net_struct BASECLASS {unsigned int type_;int height;int width;M2_ArrayString body;};
struct nets_NetList_struct BASECLASS {nets_NetList previous;nets_Net item;};
struct vararray_vararrayint_struct BASECLASS {M2_arrayint ints;int size;};
struct errio_BasicManipulator_struct BASECLASS {int (*fun)(errio_BasicFile);};
struct stdio_file_struct BASECLASS {unsigned int type_;int hash;M2_string filename;int pid;char error;M2_string errorMessage;char listener;int listenerfd;int connection;int numconns;char input;int infd;char inisatty;M2_string inbuffer;int inindex;int insize;char eof;char promptq;M2_string (*prompt)();M2_string (*reward)();char fulllines;char bol;char echo;int echoindex;char output;int outfd;char outisatty;M2_string outbuffer;int outindex;int outbol;char hadNet;nets_NetList nets;int bytesWritten;int lastCharOut;char readline;};
struct stdio_errmsg_struct BASECLASS {unsigned int type_;M2_string message;};
struct stdio_FileCell_struct BASECLASS {stdio_file file;stdio_FileCell next;};
struct stdio_Manipulator_struct BASECLASS {int (*fun)(stdio_file);};
struct gmp_ZZcell_struct BASECLASS {unsigned int type_;__mpz_struct * v;};
struct gmp_ZZpair_struct BASECLASS {__mpz_struct * a;__mpz_struct * b;};
struct gmp_QQcell_struct BASECLASS {unsigned int type_;__mpq_struct * v;};
struct gmp_RRcell_struct BASECLASS {unsigned int type_;__mpfr_struct * v;};
struct gmp_CC_struct BASECLASS {__mpfr_struct * re;__mpfr_struct * im;};
struct gmp_CCcell_struct BASECLASS {unsigned int type_;gmp_CC v;};
struct engine_RawMatrixPair_struct BASECLASS {const struct Matrix * a;const struct Matrix * b;};
struct engine_RawArrayPair_struct BASECLASS {engine_RawMonomialArray monoms;engine_RawRingElementArray coeffs;};
struct engine_RawMonomialPair_struct BASECLASS {const struct Monomial * a;const struct Monomial * b;};
struct engine_RawRingElementPair_struct BASECLASS {const struct RingElement * a;const struct RingElement * b;};
struct engine_RawMatrixAndInt_struct BASECLASS {const struct Matrix * M;int i;};
struct engine_RawComputationCell_struct BASECLASS {unsigned int type_;struct Computation * p;};
struct engine_RawFreeModuleCell_struct BASECLASS {unsigned int type_;const struct FreeModule * p;};
struct engine_RawMatrixCell_struct BASECLASS {unsigned int type_;const struct Matrix * p;};
struct engine_RawMonoidCell_struct BASECLASS {unsigned int type_;const struct Monoid * p;};
struct engine_RawMonomialCell_struct BASECLASS {unsigned int type_;const struct Monomial * p;};
struct engine_RawMonomialIdealCell_struct BASECLASS {unsigned int type_;const struct MonomialIdeal * p;};
struct engine_RawMonomialOrderingCell_struct BASECLASS {unsigned int type_;const struct MonomialOrdering * p;};
struct engine_RawMutableMatrixCell_struct BASECLASS {unsigned int type_;struct MutableMatrix * p;};
struct engine_RawStraightLineProgramCell_struct BASECLASS {unsigned int type_;struct StraightLineProgram * p;};
struct engine_RawPathTrackerCell_struct BASECLASS {unsigned int type_;struct PathTracker * p;};
struct engine_RawRingCell_struct BASECLASS {unsigned int type_;const struct Ring * p;};
struct engine_RawRingElementCell_struct BASECLASS {unsigned int type_;const struct RingElement * p;};
struct engine_RawRingMapCell_struct BASECLASS {unsigned int type_;const struct RingMap * p;};
/* basic types */
/* functions */
extern void engine__prepare() __attribute__ ((constructor));
extern unsigned long engine_hash(const struct Monomial *);
extern M2_string engine_tostring(const struct Monomial *);
extern engine_RawMonomialIdealOrNull engine_star__8(const struct MonomialIdeal *,const struct MonomialIdeal *);
extern engine_RawMonomialIdealOrNull engine_minus__6(const struct MonomialIdeal *,const struct MonomialIdeal *);
extern engine_RawMonomialIdealOrNull engine_plus__3(const struct MonomialIdeal *,const struct MonomialIdeal *);
extern engine_RawMutableMatrixOrNull engine_star__7(struct MutableMatrix *,struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_star__6(const struct Matrix *,const struct Matrix *);
extern engine_RawMutableMatrixOrNull engine_star__5(struct MutableMatrix *,const struct RingElement *);
extern engine_RawMutableMatrixOrNull engine_star__4(const struct RingElement *,struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_star__3(const struct Matrix *,const struct RingElement *);
extern engine_RawMatrixOrNull engine_star__2(const struct RingElement *,const struct Matrix *);
extern engine_RawMutableMatrixOrNull engine_minus__5(struct MutableMatrix *,struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_minus__4(const struct Matrix *,const struct Matrix *);
extern struct MutableMatrix * engine_minus__3(struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_minus__2(const struct Matrix *);
extern engine_RawMutableMatrixOrNull engine_plus__2(struct MutableMatrix *,struct MutableMatrix *);
extern engine_RawMatrixOrNull engine_plus__1(const struct Matrix *,const struct Matrix *);
extern engine_RawRingElementOrNull engine_circ__1(const struct RingElement *,__mpz_struct *);
extern engine_RawRingElementOrNull engine_pct_(const struct RingElement *,const struct RingElement *);
extern engine_RawRingElementOrNull engine_slash_slash_(const struct RingElement *,const struct RingElement *);
extern engine_RawRingElementOrNull engine_star__1(const struct RingElement *,const struct RingElement *);
extern engine_RawRingElementOrNull engine_minus__1(const struct RingElement *,const struct RingElement *);
extern const struct RingElement * engine_minus_(const struct RingElement *);
extern engine_RawRingElementOrNull engine_plus_(const struct RingElement *,const struct RingElement *);
extern engine_RawMonomialOrNull engine_slash_(const struct Monomial *,const struct Monomial *);
extern engine_RawMonomialOrNull engine_circ_(const struct Monomial *,int);
extern engine_RawMonomialOrNull engine_star_(const struct Monomial *,const struct Monomial *);
extern M2_string engine_EngineError(M2_string);
extern void gmp__prepare() __attribute__ ((constructor));
extern gmp_CC gmp_circ__14(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_circ__13(gmp_CC,__mpz_struct *);
extern gmp_CC gmp_circ__12(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_circ__11(gmp_CC,gmp_CC);
extern gmp_CC gmp_atan_1(gmp_CC);
extern __mpfr_struct * gmp_abs2(gmp_CC);
extern gmp_CC gmp_asin_1(gmp_CC);
extern gmp_CC gmp_acos_1(gmp_CC);
extern gmp_CC gmp_csch_1(gmp_CC);
extern gmp_CC gmp_sech_1(gmp_CC);
extern gmp_CC gmp_coth_1(gmp_CC);
extern gmp_CC gmp_tanh_1(gmp_CC);
extern gmp_CC gmp_sinh_1(gmp_CC);
extern gmp_CC gmp_cosh_1(gmp_CC);
extern gmp_CC gmp_sec_1(gmp_CC);
extern gmp_CC gmp_csc_1(gmp_CC);
extern gmp_CC gmp_tan_1(gmp_CC);
extern gmp_CC gmp_cot_1(gmp_CC);
extern gmp_CC gmp_sin_1(gmp_CC);
extern gmp_CC gmp_cos_1(gmp_CC);
extern gmp_CC gmp_agm_1(gmp_CC,gmp_CC);
extern gmp_CC gmp_log_5(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_log_4(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_log_3(gmp_CC,gmp_CC);
extern gmp_CC gmp_logc_1(__mpfr_struct *,__mpfr_struct *);
extern gmp_CC gmp_logc(__mpfr_struct *);
extern gmp_CC gmp_log_2(gmp_CC);
extern gmp_CC gmp_exp_1(gmp_CC);
extern M2_string gmp_toExternalString_1(gmp_CC);
extern M2_string gmp_tonetCCparen(gmp_CC);
extern M2_string gmp_tonetCC(gmp_CC);
extern M2_string gmp_tostringCC(gmp_CC);
extern M2_string gmp_format_1(int,int,int,int,M2_string,char,char,gmp_CC);
extern M2_string gmp_toExternalString(__mpfr_struct *);
extern M2_string gmp_tostringRR(__mpfr_struct *);
extern M2_string gmp_printingSeparator;
extern int gmp_printingTrailLimit;
extern int gmp_printingLeadLimit;
extern int gmp_printingAccuracy;
extern int gmp_printingPrecision;
extern M2_ArrayString gmp_format(int,int,int,int,M2_string,__mpfr_struct *);
extern char gmp_sign(__mpfr_struct *);
extern __mpfr_struct * gmp_yn(long,__mpfr_struct *);
extern __mpfr_struct * gmp_y1(__mpfr_struct *);
extern __mpfr_struct * gmp_y0(__mpfr_struct *);
extern __mpfr_struct * gmp_jn(long,__mpfr_struct *);
extern __mpfr_struct * gmp_j1(__mpfr_struct *);
extern __mpfr_struct * gmp_j0(__mpfr_struct *);
extern __mpfr_struct * gmp_erfc(__mpfr_struct *);
extern __mpfr_struct * gmp_erf(__mpfr_struct *);
extern __mpfr_struct * gmp_zeta_1(unsigned long,unsigned long);
extern __mpfr_struct * gmp_zeta(__mpfr_struct *);
extern __mpfr_struct * gmp_eint(__mpfr_struct *);
extern __mpfr_struct * gmp_factorial_1(__mpfr_struct *);
extern __mpfr_struct * gmp_Gamma(__mpfr_struct *);
extern __mpfr_struct * gmp_expm1(__mpfr_struct *);
extern __mpfr_struct * gmp_log1p(__mpfr_struct *);
extern __mpz_struct * gmp_factorial(unsigned long);
extern __mpfr_struct * gmp_coth(__mpfr_struct *);
extern __mpfr_struct * gmp_csch(__mpfr_struct *);
extern __mpfr_struct * gmp_sech(__mpfr_struct *);
extern __mpfr_struct * gmp_cot(__mpfr_struct *);
extern __mpfr_struct * gmp_csc(__mpfr_struct *);
extern __mpfr_struct * gmp_sec(__mpfr_struct *);
extern __mpfr_struct * gmp_tanh(__mpfr_struct *);
extern __mpfr_struct * gmp_cosh(__mpfr_struct *);
extern __mpfr_struct * gmp_sinh(__mpfr_struct *);
extern __mpfr_struct * gmp_agm(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_atan2(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_atan(__mpfr_struct *);
extern __mpfr_struct * gmp_acos(__mpfr_struct *);
extern __mpfr_struct * gmp_asin(__mpfr_struct *);
extern __mpfr_struct * gmp_tan(__mpfr_struct *);
extern __mpfr_struct * gmp_cos(__mpfr_struct *);
extern __mpfr_struct * gmp_sin(__mpfr_struct *);
extern __mpfr_struct * gmp_log_1(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_log(__mpfr_struct *);
extern __mpfr_struct * gmp_exp(__mpfr_struct *);
extern __mpfr_struct * gmp_pi(unsigned long);
extern gmp_CC gmp_sqrt_1(gmp_CC);
extern __mpfr_struct * gmp_abs_3(gmp_CC);
extern int gmp_compare_15(__mpq_struct *,gmp_CC);
extern int gmp_compare_14(gmp_CC,__mpq_struct *);
extern int gmp_compare_13(__mpz_struct *,gmp_CC);
extern int gmp_compare_12(gmp_CC,__mpz_struct *);
extern int gmp_compare_11(__mpfr_struct *,gmp_CC);
extern int gmp_compare_10(gmp_CC,__mpfr_struct *);
extern int gmp_compare_9(gmp_CC,gmp_CC);
extern char gmp_equal_equal_equal__23(__mpq_struct *,gmp_CC);
extern char gmp_equal_equal_equal__22(gmp_CC,__mpq_struct *);
extern char gmp_equal_equal_equal__21(__mpz_struct *,gmp_CC);
extern char gmp_equal_equal_equal__20(gmp_CC,__mpz_struct *);
extern char gmp_equal_equal_equal__19(__mpfr_struct *,gmp_CC);
extern char gmp_equal_equal_equal__18(gmp_CC,__mpfr_struct *);
extern char gmp_equal_equal_equal__17(gmp_CC,gmp_CC);
extern char gmp_strictequality_1(gmp_CC,gmp_CC);
extern gmp_CC gmp_slash__20(int,gmp_CC);
extern gmp_CC gmp_slash__19(__mpz_struct *,gmp_CC);
extern gmp_CC gmp_slash__18(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_slash__17(gmp_CC,gmp_CC);
extern gmp_CC gmp_inverse(gmp_CC);
extern gmp_CC gmp_greater_greater__4(gmp_CC,int);
extern gmp_CC gmp_less_less__7(gmp_CC,int);
extern gmp_CC gmp_greater_greater__3(gmp_CC,long);
extern gmp_CC gmp_less_less__6(gmp_CC,long);
extern __mpfr_struct * gmp_norm2(gmp_CC);
extern gmp_CC gmp_conj(gmp_CC);
extern gmp_CC gmp_slash__16(gmp_CC,int);
extern gmp_CC gmp_slash__15(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_star__25(gmp_CC,gmp_CC);
extern gmp_CC gmp_star__24(__mpz_struct *,gmp_CC);
extern gmp_CC gmp_star__23(gmp_CC,__mpz_struct *);
extern gmp_CC gmp_star__22(int,gmp_CC);
extern gmp_CC gmp_star__21(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_star__20(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_minus__24(gmp_CC);
extern gmp_CC gmp_plus__20(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_plus__19(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_minus__23(gmp_CC,__mpfr_struct *);
extern gmp_CC gmp_minus__22(int,gmp_CC);
extern gmp_CC gmp_minus__21(__mpfr_struct *,gmp_CC);
extern gmp_CC gmp_minus__20(gmp_CC,gmp_CC);
extern gmp_CC gmp_plus__18(gmp_CC,gmp_CC);
extern __mpfr_struct * gmp_greater_greater__2(__mpfr_struct *,int);
extern __mpfr_struct * gmp_less_less__5(__mpfr_struct *,int);
extern __mpfr_struct * gmp_greater_greater__1(__mpfr_struct *,long);
extern __mpfr_struct * gmp_less_less__4(__mpfr_struct *,long);
extern __mpz_struct * gmp_round(__mpfr_struct *);
extern __mpz_struct * gmp_ceil(__mpfr_struct *);
extern __mpz_struct * gmp_floor_1(__mpfr_struct *);
extern __mpfr_struct * gmp_circ__10(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_circ__9(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_circ__8(unsigned long,__mpfr_struct *);
extern __mpfr_struct * gmp_pow10_2(int,unsigned long);
extern __mpfr_struct * gmp_pow10_1(long,unsigned long);
extern __mpfr_struct * gmp_pow10(unsigned long,unsigned long);
extern __mpfr_struct * gmp_circ__7(__mpfr_struct *,unsigned long);
extern __mpfr_struct * gmp_circ__6(__mpfr_struct *,long);
extern __mpfr_struct * gmp_sqrt(__mpfr_struct *);
extern __mpfr_struct * gmp_slash__14(__mpfr_struct *,__mpq_struct *);
extern __mpfr_struct * gmp_slash__13(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_slash__12(__mpfr_struct *,int);
extern __mpfr_struct * gmp_slash__11(__mpfr_struct *,long);
extern __mpfr_struct * gmp_slash__10(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_star__19(__mpfr_struct *,__mpq_struct *);
extern __mpfr_struct * gmp_star__18(int,__mpfr_struct *);
extern __mpfr_struct * gmp_star__17(__mpfr_struct *,int);
extern __mpfr_struct * gmp_star__16(__mpz_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_star__15(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_star__14(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_abs_2(__mpfr_struct *);
extern __mpfr_struct * gmp_minus__19(__mpfr_struct *,__mpq_struct *);
extern __mpfr_struct * gmp_minus__18(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_minus__17(int,__mpfr_struct *);
extern __mpfr_struct * gmp_minus__16(__mpfr_struct *,int);
extern __mpfr_struct * gmp_minus__15(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_minus__14(__mpfr_struct *);
extern __mpfr_struct * gmp_plus__17(__mpfr_struct *,__mpq_struct *);
extern __mpfr_struct * gmp_plus__16(__mpfr_struct *,__mpz_struct *);
extern __mpfr_struct * gmp_plus__15(__mpfr_struct *,int);
extern __mpfr_struct * gmp_plus__14(__mpfr_struct *,__mpfr_struct *);
extern int gmp_hash_3(gmp_CC);
extern int gmp_hash_2(__mpfr_struct *);
extern char gmp_less_equal__16(__mpfr_struct *,__mpq_struct *);
extern char gmp_less__16(__mpfr_struct *,__mpq_struct *);
extern char gmp_equal_equal_equal__16(__mpq_struct *,__mpfr_struct *);
extern char gmp_equal_equal_equal__15(__mpfr_struct *,__mpq_struct *);
extern char gmp_greater_equal__16(__mpfr_struct *,__mpq_struct *);
extern char gmp_greater__16(__mpfr_struct *,__mpq_struct *);
extern int gmp_compare_8(__mpq_struct *,__mpfr_struct *);
extern int gmp_compare_7(__mpfr_struct *,__mpq_struct *);
extern char gmp_less_equal__15(__mpfr_struct *,__mpz_struct *);
extern char gmp_less__15(__mpfr_struct *,__mpz_struct *);
extern char gmp_equal_equal_equal__14(__mpz_struct *,__mpfr_struct *);
extern char gmp_equal_equal_equal__13(__mpfr_struct *,__mpz_struct *);
extern char gmp_greater_equal__15(__mpfr_struct *,__mpz_struct *);
extern char gmp_greater__15(__mpfr_struct *,__mpz_struct *);
extern int gmp_compare_6(__mpz_struct *,__mpfr_struct *);
extern int gmp_compare_5(__mpfr_struct *,__mpz_struct *);
extern char gmp_less_equal__14(__mpfr_struct *,double);
extern char gmp_less__14(__mpfr_struct *,double);
extern char gmp_equal_equal_equal__12(__mpfr_struct *,double);
extern char gmp_greater_equal__14(__mpfr_struct *,double);
extern char gmp_greater__14(__mpfr_struct *,double);
extern int gmp_compare_4(double,__mpfr_struct *);
extern int gmp_compare_3(__mpfr_struct *,double);
extern char gmp_equal_equal_equal__11(gmp_CC,int);
extern char gmp_less_equal__13(__mpfr_struct *,int);
extern char gmp_less__13(__mpfr_struct *,int);
extern char gmp_equal_equal_equal__10(__mpfr_struct *,int);
extern char gmp_greater_equal__13(__mpfr_struct *,int);
extern char gmp_greater__13(__mpfr_struct *,int);
extern int gmp_compare_2(long,__mpfr_struct *);
extern int gmp_compare_1(__mpfr_struct *,long);
extern char gmp_less_equal__12(__mpfr_struct *,__mpfr_struct *);
extern char gmp_greater_equal__12(__mpfr_struct *,__mpfr_struct *);
extern char gmp_less__12(__mpfr_struct *,__mpfr_struct *);
extern char gmp_greater__12(__mpfr_struct *,__mpfr_struct *);
extern int gmp_compare(__mpfr_struct *,__mpfr_struct *);
extern char gmp_strictequality(__mpfr_struct *,__mpfr_struct *);
extern char gmp_equal_equal_equal__9(__mpfr_struct *,__mpfr_struct *);
extern char gmp_isnan_1(gmp_CC);
extern char gmp_isinf_1(gmp_CC);
extern char gmp_isfinite_1(gmp_CC);
extern char gmp_isnan(__mpfr_struct *);
extern char gmp_isinf(__mpfr_struct *);
extern char gmp_isfinite(__mpfr_struct *);
extern char gmp_flagged();
extern double gmp_toDouble_4(gmp_RRcell);
extern double gmp_toDouble_3(__mpfr_struct *);
extern gmp_CC gmp_toCC_14(double,double,unsigned long);
extern gmp_CC gmp_toCC_13(double,unsigned long);
extern gmp_CC gmp_toCC_12(unsigned long,unsigned long);
extern gmp_CC gmp_toCC_11(int,int,unsigned long);
extern gmp_CC gmp_toCC_10(int,unsigned long);
extern gmp_CC gmp_toCC_9(__mpz_struct *);
extern gmp_CC gmp_toCC_8(__mpq_struct *);
extern gmp_CC gmp_toCC_7(__mpz_struct *,unsigned long);
extern gmp_CC gmp_toCC_6(__mpq_struct *,unsigned long);
extern gmp_CC gmp_toCC_5(__mpfr_struct *,__mpfr_struct *,unsigned long);
extern gmp_CC gmp_toCC_4(gmp_CC,unsigned long);
extern gmp_CC gmp_toCC_3(__mpfr_struct *,unsigned long);
extern gmp_CC gmp_toCC_2(int,__mpfr_struct *);
extern gmp_CC gmp_toCC_1(__mpfr_struct *);
extern gmp_CC gmp_nanCC(unsigned long);
extern gmp_CC gmp_infinityCC(unsigned long);
extern gmp_CC gmp_toCC(__mpfr_struct *,__mpfr_struct *);
extern __mpfr_struct * gmp_nanRR(unsigned long);
extern __mpfr_struct * gmp_infinityRR_1(unsigned long);
extern __mpfr_struct * gmp_infinityRR(unsigned long,int);
extern __mpfr_struct * gmp_toRR_9(double);
extern __mpfr_struct * gmp_toRR_8(double,unsigned long);
extern __mpfr_struct * gmp_toRR_7(unsigned long,unsigned long);
extern __mpfr_struct * gmp_toRR_6(int,unsigned long);
extern __mpfr_struct * gmp_toRR_5(__mpz_struct *);
extern __mpfr_struct * gmp_toRR_4(__mpz_struct *,unsigned long);
extern __mpfr_struct * gmp_toRR_3(__mpq_struct *);
extern __mpfr_struct * gmp_toRR_2(__mpq_struct *,unsigned long);
extern __mpfr_struct * gmp_toRR_1(M2_string,unsigned long);
extern __mpfr_struct * gmp_toRR(__mpfr_struct *,unsigned long);
extern unsigned long gmp_precision_1(gmp_CC);
extern unsigned long gmp_precision(__mpfr_struct *);
extern gmp_CC gmp_newCC(unsigned long);
extern __mpfr_struct * gmp_newRR(unsigned long);
extern long gmp_exponent_2(gmp_CC);
extern long gmp_exponent_1(__mpfr_struct *);
extern long gmp_exponent(__mpz_struct *);
extern long gmp_maxExponent;
extern long gmp_minExponent;
extern unsigned long gmp_maxprec;
extern unsigned long gmp_minprec;
extern unsigned long gmp_defaultPrecision;
extern char gmp_isZero_2(gmp_CC);
extern char gmp_isZero_1(__mpfr_struct *);
extern char gmp_isNegative_2(__mpfr_struct *);
extern char gmp_isPositive_1(__mpfr_struct *);
extern __mpfr_struct * gmp_imaginaryPart(gmp_CC);
extern __mpfr_struct * gmp_realPart(gmp_CC);
extern char gmp_greater_equal__11(__mpq_struct *,double);
extern char gmp_greater__11(__mpq_struct *,double);
extern char gmp_less_equal__11(__mpq_struct *,double);
extern char gmp_less__11(__mpq_struct *,double);
extern char gmp_greater_equal__10(double,__mpq_struct *);
extern char gmp_greater__10(double,__mpq_struct *);
extern char gmp_less_equal__10(double,__mpq_struct *);
extern char gmp_less__10(double,__mpq_struct *);
extern double gmp_slash__9(__mpq_struct *,double);
extern double gmp_star__13(__mpq_struct *,double);
extern double gmp_minus__13(__mpq_struct *,double);
extern double gmp_plus__13(__mpq_struct *,double);
extern double gmp_slash__8(double,__mpq_struct *);
extern double gmp_star__12(double,__mpq_struct *);
extern double gmp_minus__12(double,__mpq_struct *);
extern double gmp_plus__12(double,__mpq_struct *);
extern double gmp_toDouble_2(__mpq_struct *);
extern char gmp_greater_equal__9(int,__mpq_struct *);
extern char gmp_greater__9(int,__mpq_struct *);
extern char gmp_less_equal__9(int,__mpq_struct *);
extern char gmp_less__9(int,__mpq_struct *);
extern char gmp_less_equal__8(__mpq_struct *,int);
extern char gmp_greater__8(__mpq_struct *,int);
extern char gmp_greater_equal__8(__mpq_struct *,int);
extern char gmp_less__8(__mpq_struct *,int);
extern char gmp_greater_equal__7(__mpq_struct *,__mpz_struct *);
extern char gmp_greater__7(__mpq_struct *,__mpz_struct *);
extern char gmp_less_equal__7(__mpq_struct *,__mpz_struct *);
extern char gmp_less__7(__mpq_struct *,__mpz_struct *);
extern char gmp_greater_equal__6(__mpz_struct *,__mpq_struct *);
extern char gmp_greater__6(__mpz_struct *,__mpq_struct *);
extern char gmp_less_equal__6(__mpz_struct *,__mpq_struct *);
extern char gmp_less__6(__mpz_struct *,__mpq_struct *);
extern char gmp_less_equal__5(__mpq_struct *,__mpq_struct *);
extern char gmp_greater__5(__mpq_struct *,__mpq_struct *);
extern char gmp_greater_equal__5(__mpq_struct *,__mpq_struct *);
extern char gmp_less__5(__mpq_struct *,__mpq_struct *);
extern char gmp_equal_equal_equal__8(int,__mpq_struct *);
extern char gmp_equal_equal_equal__7(__mpz_struct *,__mpq_struct *);
extern char gmp_equal_equal_equal__6(__mpq_struct *,int);
extern char gmp_equal_equal_equal__5(__mpq_struct *,__mpz_struct *);
extern stdio_file gmp_less_less__3(stdio_file,__mpq_struct *);
extern M2_string gmp_tostring_1(__mpq_struct *);
extern __mpq_struct * gmp_circ__5(__mpq_struct *,__mpz_struct *);
extern __mpq_struct * gmp_slash__7(int,__mpq_struct *);
extern __mpq_struct * gmp_slash__6(__mpz_struct *,__mpq_struct *);
extern __mpq_struct * gmp_slash__5(__mpq_struct *,int);
extern __mpq_struct * gmp_slash__4(__mpq_struct *,__mpz_struct *);
extern __mpq_struct * gmp_slash__3(__mpz_struct *,__mpz_struct *);
extern __mpq_struct * gmp_star__11(int,__mpq_struct *);
extern __mpq_struct * gmp_star__10(__mpz_struct *,__mpq_struct *);
extern __mpq_struct * gmp_star__9(__mpq_struct *,int);
extern __mpq_struct * gmp_star__8(__mpq_struct *,__mpz_struct *);
extern __mpq_struct * gmp_minus__11(int,__mpq_struct *);
extern __mpq_struct * gmp_minus__10(__mpz_struct *,__mpq_struct *);
extern __mpq_struct * gmp_minus__9(__mpq_struct *,int);
extern __mpq_struct * gmp_minus__8(__mpq_struct *,__mpz_struct *);
extern __mpq_struct * gmp_plus__11(int,__mpq_struct *);
extern __mpq_struct * gmp_plus__10(__mpz_struct *,__mpq_struct *);
extern __mpq_struct * gmp_plus__9(__mpq_struct *,int);
extern __mpq_struct * gmp_plus__8(__mpq_struct *,__mpz_struct *);
extern char gmp_equal_equal_equal__4(__mpq_struct *,__mpq_struct *);
extern __mpq_struct * gmp_slash__2(__mpq_struct *,__mpq_struct *);
extern __mpq_struct * gmp_star__7(__mpq_struct *,__mpq_struct *);
extern __mpq_struct * gmp_minus__7(__mpq_struct *,__mpq_struct *);
extern __mpq_struct * gmp_inv(__mpq_struct *);
extern __mpq_struct * gmp_abs_1(__mpq_struct *);
extern __mpq_struct * gmp_minus__6(__mpq_struct *);
extern __mpq_struct * gmp_plus__7(__mpq_struct *,__mpq_struct *);
extern __mpz_struct * gmp_floor(__mpq_struct *);
extern __mpq_struct * gmp_toRational_2(__mpz_struct *);
extern __mpq_struct * gmp_toRational_1(unsigned long);
extern __mpq_struct * gmp_toRational(int);
extern __mpq_struct * gmp_newRationalCanonical(__mpz_struct *,__mpz_struct *);
extern __mpq_struct * gmp_newRational(__mpz_struct *,__mpz_struct *);
extern char gmp_isNegative_1(__mpq_struct *);
extern int gmp_hash_1(__mpq_struct *);
extern __mpz_struct * gmp_denominator(__mpq_struct *);
extern __mpz_struct * gmp_numerator(__mpq_struct *);
extern char gmp_greater_equal__4(double,__mpz_struct *);
extern char gmp_less_equal__4(double,__mpz_struct *);
extern char gmp_greater__4(double,__mpz_struct *);
extern char gmp_less__4(double,__mpz_struct *);
extern char gmp_less_equal__3(__mpz_struct *,double);
extern char gmp_greater_equal__3(__mpz_struct *,double);
extern char gmp_less__3(__mpz_struct *,double);
extern char gmp_greater__3(__mpz_struct *,double);
extern double gmp_circ__4(double,__mpz_struct *);
extern double gmp_slash__1(__mpz_struct *,double);
extern double gmp_slash_(double,__mpz_struct *);
extern double gmp_star__6(__mpz_struct *,double);
extern double gmp_star__5(double,__mpz_struct *);
extern double gmp_minus__5(__mpz_struct *,double);
extern double gmp_minus__4(double,__mpz_struct *);
extern double gmp_plus__6(__mpz_struct *,double);
extern double gmp_plus__5(double,__mpz_struct *);
extern double gmp_toDouble_1(gmp_ZZcell);
extern double gmp_toDouble(__mpz_struct *);
extern stdio_file gmp_less_less__2(stdio_file,__mpz_struct *);
extern __mpz_struct * gmp_circ__3(int,unsigned long);
extern __mpz_struct * gmp_star__4(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_star__3(unsigned long,__mpz_struct *);
extern __mpz_struct * gmp_star__2(__mpz_struct *,int);
extern __mpz_struct * gmp_star__1(int,__mpz_struct *);
extern __mpz_struct * gmp_minus__3(__mpz_struct *,int);
extern __mpz_struct * gmp_minus__2(int,__mpz_struct *);
extern __mpz_struct * gmp_plus__4(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_plus__3(unsigned long,__mpz_struct *);
extern __mpz_struct * gmp_plus__2(__mpz_struct *,int);
extern __mpz_struct * gmp_plus__1(int,__mpz_struct *);
extern M2_string gmp_tostring(__mpz_struct *);
extern __mpz_struct * gmp_circ_circ_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_or_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_amp_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_greater_greater_(__mpz_struct *,int);
extern __mpz_struct * gmp_less_less__1(__mpz_struct *,int);
extern __mpz_struct * gmp_gcd(__mpz_struct *,__mpz_struct *);
extern unsigned short gmp_pct__2(__mpz_struct *,unsigned short);
extern unsigned long gmp_pct__1(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_slash_slash__2(__mpz_struct *,unsigned short);
extern __mpz_struct * gmp_slash_slash__1(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_pct_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_slash_slash_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_powermod(__mpz_struct *,__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_circ__2(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_circ__1(__mpz_struct *,int);
extern __mpz_struct * gmp_circ_(__mpz_struct *,unsigned long);
extern __mpz_struct * gmp_star_(__mpz_struct *,__mpz_struct *);
extern char gmp_equal_equal_equal__3(int,__mpz_struct *);
extern char gmp_greater_equal__2(int,__mpz_struct *);
extern char gmp_less_equal__2(int,__mpz_struct *);
extern char gmp_greater__2(int,__mpz_struct *);
extern char gmp_less__2(int,__mpz_struct *);
extern char gmp_less_equal__1(__mpz_struct *,int);
extern char gmp_less__1(__mpz_struct *,int);
extern char gmp_equal_equal_equal__2(gmp_ZZcell,int);
extern char gmp_equal_equal_equal__1(__mpz_struct *,int);
extern char gmp_greater_equal__1(__mpz_struct *,int);
extern char gmp_greater__1(__mpz_struct *,int);
extern char gmp_less_equal_(__mpz_struct *,__mpz_struct *);
extern char gmp_greater_equal_(__mpz_struct *,__mpz_struct *);
extern char gmp_less_(__mpz_struct *,__mpz_struct *);
extern char gmp_greater_(__mpz_struct *,__mpz_struct *);
extern char gmp_equal_equal_equal_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_minus__1(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_plus_(__mpz_struct *,__mpz_struct *);
extern __mpz_struct * gmp_abs(__mpz_struct *);
extern __mpz_struct * gmp_minus_(__mpz_struct *);
extern __mpz_struct * gmp_toInteger_3(long);
extern __mpz_struct * gmp_toInteger_2(unsigned long);
extern __mpz_struct * gmp_toInteger_1(unsigned short);
extern __mpz_struct * gmp_toInteger(int);
extern __mpz_struct * gmp_copy(__mpz_struct *);
extern __mpz_struct * gmp_newZZ();
extern int gmp_hash(__mpz_struct *);
extern unsigned long gmp_toULong_1(gmp_ZZcell);
extern unsigned long gmp_toULong(__mpz_struct *);
extern char gmp_isULong_1(gmp_ZZcell);
extern char gmp_isULong(__mpz_struct *);
extern long gmp_toLong_1(gmp_ZZcell);
extern long gmp_toLong(__mpz_struct *);
extern char gmp_isLong_1(gmp_ZZcell);
extern char gmp_isLong(__mpz_struct *);
extern int gmp_toInt_1(gmp_ZZcell);
extern int gmp_toInt(__mpz_struct *);
extern char gmp_isInt_1(gmp_ZZcell);
extern char gmp_isInt(__mpz_struct *);
extern unsigned short gmp_toUShort(__mpz_struct *);
extern char gmp_isUShort(__mpz_struct *);
extern char gmp_isOdd(__mpz_struct *);
extern char gmp_isEven(__mpz_struct *);
extern char gmp_isNegative(__mpz_struct *);
extern char gmp_isZero(__mpz_struct *);
extern char gmp_isPositive(__mpz_struct *);
extern stdio_file gmp_less_less_(stdio_file,M2_charstarOrNull);
extern unsigned long gmp_max_3(unsigned long,unsigned long);
extern unsigned long gmp_min_3(unsigned long,unsigned long);
extern long gmp_max_2(long,long);
extern long gmp_min_2(long,long);
extern unsigned int gmp_max_1(unsigned int,unsigned int);
extern unsigned int gmp_min_1(unsigned int,unsigned int);
extern int gmp_max(int,int);
extern int gmp_min(int,int);
extern M2_string (*gmp_tonetCCparenpointer)(gmp_CC);
extern M2_string (*gmp_tonetCCpointer)(gmp_CC);
extern M2_string (*gmp_tostringRRpointer)(__mpfr_struct *);
extern void err__prepare() __attribute__ ((constructor));
extern void err_less_less_(stdio_file,stdio_errmsg);
extern void err_syserr_1(stdio_errmsg);
extern void err_fatal_1(stdio_errmsg);
extern void err_error_1(stdio_errmsg);
extern void err_warning_1(stdio_errmsg);
extern void err_syserr(M2_string);
extern void err_abort(M2_string);
extern void err_fatal(M2_string);
extern void err_error(M2_string);
extern void err_warning(M2_string);
extern void stdio__prepare() __attribute__ ((constructor));
extern stdio_file stdio_less_less__15(stdio_file,unsigned long);
extern stdio_file stdio_less_less__14(stdio_file,long);
extern void stdio_endLine(stdio_file);
extern char stdio_atEndOfLine(stdio_file);
extern int stdio_fchmod(stdio_file,int);
extern int stdio_less_less__13(errio_BasicFile,stdio_Manipulator);
extern stdio_Manipulator stdio_Flush;
extern stdio_Manipulator stdio_endl;
extern stdio_file stdio_less_less__12(stdio_file,stdio_Manipulator);
extern stdio_StringOrError stdio_get(M2_string);
extern void stdio_clean(stdio_file);
extern void stdio_unsetprompt(stdio_file);
extern void stdio_setprompt(stdio_file,M2_string (*)());
extern stdio_file stdio_less_less__11(stdio_file,int,int);
extern stdio_file stdio_less_less__10(stdio_file,M2_string,int);
extern varstrin_varstring stdio_less_less__9(varstrin_varstring,int);
extern M2_string stdio_blanks(int);
extern int stdio_peek_1(stdio_file);
extern int stdio_peek(stdio_file,int);
extern stdio_StringOrError stdio_read(stdio_file);
extern int stdio_getc(stdio_file);
extern stdio_file stdio_less_less__8(stdio_file,double);
extern M2_string stdio_tostringRR(double);
extern M2_string stdio_tostring5(double,int,int,int,M2_string);
extern M2_string stdio_tostring_3(char);
extern char stdio_isnan(double);
extern char stdio_isinf(double);
extern char stdio_finite(double);
extern stdio_file stdio_less_less__7(stdio_file,char);
extern stdio_file stdio_less_less__6(stdio_file,unsigned char);
extern stdio_file stdio_less_less__5(stdio_file,unsigned short);
extern stdio_file stdio_less_less__4(stdio_file,short);
extern stdio_file stdio_less_less__3(stdio_file,int);
extern int stdio_filbuf(stdio_file);
extern M2_string stdio_presentn(M2_string);
extern M2_string stdio_present_1(M2_string);
extern M2_string stdio_present(char);
extern stdio_file stdio_less_less__2(stdio_file,M2_string);
extern stdio_file stdio_less_less__1(stdio_file,char);
extern stdio_file stdio_less_less_(stdio_file,nets_Net);
extern stdio_errmsg stdio_close(stdio_file);
extern stdio_errmsg stdio_closeOut(stdio_file);
extern stdio_errmsg stdio_closeIn(stdio_file);
extern stdio_errmsg stdio_closeListener(stdio_file);
extern int stdio_flush(stdio_file);
extern void stdio_flushinput(stdio_file);
extern struct tagged_union * stdio_openListener(M2_string);
extern struct tagged_union * stdio_openInOut_1(M2_string);
extern struct tagged_union * stdio_openOutAppend(M2_string);
extern struct tagged_union * stdio_openOut_1(M2_string);
extern struct tagged_union * stdio_openIn_1(M2_string);
extern M2_string stdio_expandFileName(M2_string);
extern struct tagged_union * stdio_openInOut(stdio_file);
extern struct tagged_union * stdio_openOut(stdio_file);
extern struct tagged_union * stdio_openIn(stdio_file);
extern stdio_FileCell stdio_openfiles;
extern int stdio_lineNumber;
extern int stdio_interpreterDepth;
extern M2_string stdio_tostring_2(unsigned long);
extern M2_string stdio_tostring_1(long);
extern M2_string stdio_tostring(int);
extern __thread stdio_file stdio_stdIO;
extern stdio_file stdio_dummyfile;
extern __thread stdio_file stdio_stdError;
extern M2_string stdio_noprompt();
extern M2_string stdio_fileErrorMessage_1(stdio_file);
extern void stdio_clearFileError(stdio_file);
extern char stdio_fileError(stdio_file);
extern M2_string stdio_fileErrorMessage(stdio_file,M2_string);
extern M2_string stdio_syscallErrorMessage(M2_string);
extern char stdio_iserror(int);
extern char stdio_iseof(int);
extern int stdio_nextHash();
extern void errio__prepare() __attribute__ ((constructor));
extern errio_BasicFile errio_less_less__7(errio_BasicFile,char);
extern errio_BasicFile errio_less_less__6(errio_BasicFile,unsigned char);
extern errio_BasicFile errio_less_less__5(errio_BasicFile,unsigned short);
extern errio_BasicFile errio_less_less__4(errio_BasicFile,short);
extern errio_BasicFile errio_less_less__3(errio_BasicFile,int);
extern errio_BasicManipulator errio_basicEndl;
extern errio_BasicManipulator errio_basicFlush;
extern int errio_less_less__2(errio_BasicFile,errio_BasicManipulator);
extern errio_BasicFile errio_less_less__1(errio_BasicFile,M2_string);
extern errio_BasicFile errio_less_less_(errio_BasicFile,char);
extern __thread errio_BasicFile errio_stderr;
extern void interrupts__prepare() __attribute__ ((constructor));
extern void interrupts_clearSteppingFlag();
extern int interrupts_microStepCount;
extern int interrupts_stepCount;
extern void interrupts_clearAlarmedFlag();
extern void interrupts_clearInterruptFlag();
extern void interrupts_setSteppingFlag();
extern void interrupts_setAlarmedFlag();
extern void interrupts_setInterruptFlag();
extern void interrupts_clearAllFlags();
extern void interrupts_clearAlarm();
extern void interrupts_determineExceptionFlag();
extern __thread struct atomic_field interrupts_exceptionFlag;
extern __thread struct atomic_field interrupts_interruptedFlag;
extern __thread char interrupts_steppingFlag;
extern __thread char interrupts_alarmedFlag;
extern __thread char interrupts_interruptPending;
extern __thread char interrupts_interruptShield;
extern void atomic__prepare() __attribute__ ((constructor));
extern void nets__prepare() __attribute__ ((constructor));
extern int nets_hash(nets_Net);
extern nets_Net nets_wrap(int,char,nets_Net);
extern void vararray__prepare() __attribute__ ((constructor));
extern M2_arrayint vararray_takereversearrayint(vararray_vararrayint);
extern M2_arrayint vararray_takearrayint(vararray_vararrayint);
extern void vararray_empty(vararray_vararrayint);
extern M2_arrayint vararray_toreversearrayint(vararray_vararrayint);
extern M2_arrayint vararray_toarrayint(vararray_vararrayint);
extern vararray_vararrayint vararray_less_less__1(vararray_vararrayint,M2_arrayint);
extern vararray_vararrayint vararray_less_less_(vararray_vararrayint,int);
extern vararray_vararrayint vararray_newvararrayint(int);
extern int nets_netcmp_2(M2_string,nets_Net);
extern int nets_netcmp_1(nets_Net,M2_string);
extern int nets_netcmp(nets_Net,nets_Net);
extern nets_NetList nets_dummyNetList;
extern nets_Net nets_dummyNet;
extern nets_Net nets_HorizontalJoin_1(nets_NetList);
extern char nets_equal_equal_equal_(nets_Net,nets_Net);
extern nets_Net nets_VerticalJoin(struct M2_153 *);
extern nets_Net nets_HorizontalJoin(struct M2_153 *);
extern nets_Net nets_RaiseNet(nets_Net,int);
extern nets_Net nets_toNet_1(char);
extern nets_Net nets_toNet(M2_string);
extern M2_ArrayString nets_lines(M2_string);
extern M2_string nets_toString(nets_Net);
extern void ctype__prepare() __attribute__ ((constructor));
extern char ctype_isalnum_2(M2_string);
extern char ctype_isquote_1(char);
extern char ctype_isnewline_1(char);
extern char ctype_isspace_1(char);
extern char ctype_iswhite_1(char);
extern char ctype_isalnum_1(char);
extern char ctype_isalpha_1(char);
extern char ctype_isbinary_1(char);
extern char ctype_ishex_1(char);
extern char ctype_isdigit_1(char);
extern char ctype_isquote(int);
extern char ctype_isnewline(int);
extern char ctype_isspace(int);
extern char ctype_iswhite(int);
extern char ctype_isalnum(int);
extern char ctype_isalpha(int);
extern char ctype_isbinary(int);
extern char ctype_ishex(int);
extern char ctype_isdigit(int);
extern void varstrin__prepare() __attribute__ ((constructor));
extern M2_ArrayString varstrin_extract(varstrin_varstringarray);
extern varstrin_varstringarray varstrin_append(varstrin_varstringarray,M2_string);
extern varstrin_varstringarray varstrin_newvarstringarray(int);
extern void varstrin_putdigit(varstrin_varstring,int);
extern int varstrin_hash(varstrin_varstring);
extern M2_string varstrin_takereversestring(varstrin_varstring);
extern M2_string varstrin_takestring(varstrin_varstring);
extern void varstrin_empty(varstrin_varstring);
extern M2_string varstrin_toreversestring(varstrin_varstring);
extern M2_string varstrin_tostring(varstrin_varstring);
extern varstrin_varstring varstrin_less_less__1(varstrin_varstring,M2_string);
extern varstrin_varstring varstrin_less_less_(varstrin_varstring,char);
extern void varstrin_blankfill(int,varstrin_varstring);
extern varstrin_varstring varstrin_newvarstring(int);
extern void strings__prepare() __attribute__ ((constructor));
extern int strings_index_3(M2_string,int,char,char);
extern int strings_index_2(M2_string,int,M2_string);
extern char strings_match(M2_string,int,M2_string);
extern int strings_index_1(M2_string,int,char);
extern int strings_index(M2_string,int);
extern int strings_hash(M2_string);
extern char strings_less_equal_(M2_string,M2_string);
extern char strings_greater_(M2_string,M2_string);
extern char strings_greater_equal_(M2_string,M2_string);
extern char strings_less_(M2_string,M2_string);
extern char strings_strchr(M2_string,char);
extern char strings_equal_equal_equal_(M2_string,M2_string);
extern M2_string strings_newstring(int);
extern M2_string strings_reverse(M2_string);
extern M2_string strings_plus__2(char,M2_string);
extern M2_string strings_plus__1(M2_string,char);
extern M2_string strings_plus_(M2_string,M2_string);
extern M2_string strings_between(M2_string,M2_ArrayString);
extern M2_string strings_concatenate(M2_ArrayString);
extern void system__prepare() __attribute__ ((constructor));
extern void system_everytimeRun();
extern void system_everytime(void (*)());
extern int system_hasException(int);
extern int system_isReady(int);
extern void system_segmentationFault();
extern void system_handleInterruptsSetup(char);
extern int system_chdir(M2_string);
extern M2_ArrayString system_history();
extern int system_strncmp(M2_string,M2_string,int);
extern M2_ArrayStringOrNull system_readDirectory(M2_string);
extern M2_ArrayString system_regexselect(M2_string,M2_string,M2_string,M2_ArrayString,char);
extern M2_string system_regexreplace(M2_string,M2_string,M2_string,M2_string,char);
extern M2_arrayint system_regexmatch(M2_string,int,int,M2_string,char);
extern M2_string system_regexmatchErrorMessage;
extern M2_string system_noErrorMessage;
extern M2_string system_realpath(M2_string);
extern M2_string system_readlink(M2_string);
extern M2_ArrayStringOrNull system_wordexp(M2_string);
extern int system_isRegularFile(M2_string);
extern int system_isDirectory(M2_string);
extern int system_rmdir(M2_string);
extern int system_mkdir(M2_string);
extern int system_fileModeFD(int);
extern int system_fileMode(M2_string);
extern int system_currentTime();
extern int system_setFileTime(M2_string,int);
extern int system_fileTime(M2_string);
extern char system_fileExists(M2_string);
extern int system_fileLength_1(M2_string);
extern int system_fileLength(int);
extern M2_string system_readfile(int);
extern M2_string system_dbmstrerror();
extern int system_dbmreorganize(int);
extern M2_string system_dbmnext(int);
extern M2_string system_dbmfirst(int);
extern int system_dbmdelete(int,M2_string);
extern M2_string system_dbmfetch(int,M2_string);
extern int system_chmod(M2_string,int);
extern int system_dbmstore(int,M2_string,M2_string);
extern int system_dbmclose(int);
extern M2_string system_dbmerror();
extern int system_dbmopen(M2_string,char);
extern __thread unsigned short system_loadDepth;
extern M2_string system_errfmt(M2_string,int,int,int);
extern int system_loaddata(int,M2_string);
extern int system_dumpdata(M2_string);
extern M2_string system_getcwd();
extern int system_hash(double);
extern M2_arrayint system_select(M2_arrayint);
extern M2_arrayint system_waitNoHang(M2_arrayint);
extern int system_wait(int);
extern int system_randomint();
extern int system_strnumcmp(M2_string,M2_string);
extern int system_strcmp(M2_string,M2_string);
extern double system_cpuTime();
extern M2_string system_getenv(M2_string);
extern int system_exec(M2_ArrayString);
extern int system_pipe(M2_arrayint);
extern int system_run(M2_string);
extern void system_atend(void (*)());
extern M2_string system_strerror_1(int);
extern const char * system_strerror();
extern M2_string system_syserrmsg();
extern int system_acceptNonblocking(int);
extern int system_acceptBlocking(int);
extern int system_openlistener(M2_string,M2_string);
extern int system_opensocket(M2_string,M2_string);
extern int system_openoutappend(M2_string);
extern int system_openout(M2_string);
extern int system_openin(M2_string);
extern int system_unlink(M2_string);
extern int system_symlink(M2_string,M2_string);
extern int system_fchmod(int,int);
extern int system_link(M2_string,M2_string);
extern int system_readline(M2_string,int,int,M2_string);
extern int system_read_1(int,M2_string,int,int);
extern int system_read(int,M2_string,int);
extern int system_write_2(int,M2_string,int,int);
extern int system_write_1(int,M2_string);
extern int system_write(int,M2_string,int);
extern void system_exit(int);
extern int system_setpgid(int,int);
extern int system_getpgrp();
extern int system_getpid();
extern int system_sleep(int);
extern void M2__prepare() __attribute__ ((constructor));
extern char M2_notify;
extern __thread int M2_gbTrace;
extern M2_ArrayString M2_args;
extern M2_ArrayString M2_argv;
extern M2_ArrayString M2_envp;
extern M2_string M2_newline;
extern M2_string M2_substrAlwaysCopy(M2_string,int,int);
extern M2_string M2_substr_1(M2_string,int);
extern M2_string M2_substr(M2_string,int,int);
extern M2_string M2_enlarge(int,M2_string);
extern M2_ArrayString M2_tostrings(int,char **);
extern char ** M2_tocharstarstarmalloc(M2_ArrayString);
extern char * M2_tocharstarmalloc(M2_string);
extern char ** M2_tocharstarstar(M2_ArrayString);
extern M2_string M2_join(M2_string,M2_string);
extern M2_string M2_tostringn(char *,int);
extern M2_charstarOrNull M2_tocharstarOrNull(M2_string);
extern char * M2_tocharstar(M2_string);
extern M2_arrayint M2_makearrayint(int);
extern M2_string M2_tostring_3(const char *);
extern M2_string M2_tostring_2(char *);
extern M2_string M2_tostring_1(M2_charstarOrNull);
extern M2_string M2_tostring(M2_constcharstarOrNull);
extern void arithmetic__prepare() __attribute__ ((constructor));

#if defined(__cplusplus)
  }
#endif

#endif
